//-------------------------------------------------------------------------------------------------
//   Тест SDK для FLProg - библиотека RT_HW_BASE.h
//   Версия 1.1 21.06.2020
//   ecoins@mail.ru 
//-------------------------------------------------------------------------------------------------
#include  "RT_HW_BASE.h"
#include  "t01_device.hpp"  //--Функции и данные текущего теста;
//-------------------------------------------------------------------------------------------------
//   Пример создания доступа к некскольким строка из PROGMEM
//-------------------------------------------------------------------------------------------------
RT_HW_PGM_STR(text0) = "FLProg 7.0.1";
RT_HW_PGM_STR(text1) = "Arduino 1.8.12";
RT_HW_PGM_STR(text2) = "RT_HW_Base 1.0";
RT_HW_PGM_STR(text3) = "Проверка ARDUINO совместимости PROGMEM";
RT_HW_PGM_STR(text4) = "Проверка FLPROG";
RT_HW_PGM_STR(text5) = "Тестирование ARDUINO";
RT_HW_PGM_STR(text6) = "ARDUINO+FLPROG+KaScada+EIS=Успех";
uint8_t len; uint8_t qnt = 80;
RT_HW_PGM_P getNameStrPGM(uint8_t num = 0) {
  switch (num) {
    default: return text0;
    case 0: return text0; case 1: return text1; case 2: return text2; case 3: return text3;
    case 4: return text4; case 5: return text5; case 6: return text6;  }};
//-------------------------------------------------------------------------------------------------
//   Cозданиt строковых значений в PROGMEM
//-------------------------------------------------------------------------------------------------
RT_HW_PGM_STR(headNameTest_PGM) = "Тест RT_HW_Base.h";
RT_HW_PGM_STR(pinsTest_PGM)   = "pins:cnt,test1,test2,test3";
RT_HW_PGM_STR(pinsLedBut_PGM) = "pins:led,button,pot";
RT_HW_PGM_STR(pinsDAC_PGM)    = "pins:TCH,PWM,DAC";
RT_HW_PGM_STR(headUserPins_PGM) = "Пользовательские пины";
RT_HW_PGM_STR(headBoardPins_PGM) = "Пины и параметры контроллера";
RT_HW_PGM_STR(ADCpot_PGM) = "pot";
RT_HW_PGM_STR(ADCx4_PGM)  = "filter,normal,pwm,dac";
RT_HW_PGM_STR(HALLx4_PGM) = "HALL_device,filter,normal";
//------------------------------
RT_HW_PIN_DIR_ID idCnt, idTst1, idTst2, idTst3;
RT_HW_PIN_DIR_ID idLed, idBut;
RT_HW_PIN_ADC_ID idPot;
RT_HW_PIN_TCH_ID idTCH;
RT_HW_PIN_HALL_ID idHALL;
RT_HW_PIN_PWM_ID idPWM;
RT_HW_PIN_DAC_ID idDAC;
RT_HW_PRINT_PARAM_UINT16_ID  idPrintPot;
RT_HW_PRINT_PARAM_INT16_ID   idPrintTCH, idPrintHALL;
RT_HW_PRINT_PARAM_UINT16x4_ID idPrintADCx4;
RT_HW_PRINT_PARAM_INT16x4_ID idPrintHALLx4;
//=================================================================================================
void setup() {idPrintPot.dir=0; idPot.dir=0;}
//=================================================================================================
void loop() {
//-------------------------------------------------------------------------------------------------
//            ДИСПЕТЧЕР И КОНСОЛЬ ->вызываются в каждом цикле loop()
//-------------------------------------------------------------------------------------------------
RT_HW_Base.sheduler();            //--Мини-диспетчер;
RT_HW_Base.printBegin(115200);    //--Подключение консоли;
setNumUserPins();                 //--Установка номеров пинов под тип контроллера;
//-------------------------------------------------------------------------------------------------
//              УСТАНОВКА ПАРАМЕРОВ ->выполняется один раз
//-------------------------------------------------------------------------------------------------
if(initParam == 0) {initParam = 1;
setNumUserPins();                           //--Установка номеров пинов; 
//--Настройка параметров пинов--------------------------------------------------------------------- 
RT_HW_Base.directPinSetID(idCnt,pinCnt);    if(bitRead(idCnt.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_MODE_OUTPUT(idCnt);}
RT_HW_Base.directPinSetID(idTst1,pinTst1);  if(bitRead(idTst1.mode,RT_HW_PIN_KIND_DIR)){RT_HW_PIN_DIR_MODE_OUTPUT(idTst1);}
RT_HW_Base.directPinSetID(idTst2,pinTst2);  if(bitRead(idTst2.mode,RT_HW_PIN_KIND_DIR)){RT_HW_PIN_DIR_MODE_OUTPUT(idTst2);}
RT_HW_Base.directPinSetID(idTst3,pinTst3);  if(bitRead(idTst3.mode,RT_HW_PIN_KIND_DIR)){RT_HW_PIN_DIR_MODE_OUTPUT(idTst3);}
RT_HW_Base.directPinSetID(idLed,pinLed);    if(bitRead(idLed.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_MODE_OUTPUT(idLed);}
RT_HW_Base.directPinSetID(idBut,pinBut);    if(bitRead(idBut.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_MODE_PULLUP(idBut);}
}
//-------------------------------------------------------------------------------------------------
//           ВЫПОЛНЕНИЕ В ЦИКЛЕ  loop()
//-------------------------------------------------------------------------------------------------
//------Вывод параметров на тестовые пины----------------------------------------------------------
if(bitRead(idCnt.mode, RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_WRITE(idCnt, bitRead(RT_HW_Base.shed.blink,0));}
if(bitRead(idTst1.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_WRITE(idTst1,bitRead(RT_HW_Base.shed.blink,1));}
if(bitRead(idTst2.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_WRITE(idTst2,bitRead(RT_HW_Base.shed.blink,2));}
if(bitRead(idTst3.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_WRITE(idTst3,bitRead(RT_HW_Base.shed.blink,3));}
if(bitRead(idBut.mode, RT_HW_PIN_KIND_DIR)) {but=RT_HW_PIN_DIR_READ(idBut);}
//-------------------------------------------------------------------------------------------------
//            ВЫВОД ЗАГОЛОВКОВ (однократный вывод после готовности консоли)
//-------------------------------------------------------------------------------------------------  
if (RT_HW_Base.console.head) {RT_HW_Base.console.resetHead = 1;
RT_HW_Base.printTextPGM(headNameTest_PGM, 85, 'C', '=', 'Y'); //--Вывод заголовка из PROGMEM4;
RT_HW_Base.printHeadArchBoard();                              //--Вывод наименований и кодов платформы и контроллера;
RT_HW_Base.printHeadParamBoard();                             //--Вывод параметров контроллера;
RT_HW_Base.printTextPGM(headBoardPins_PGM,106,'C', '=', 'Y'); //--Вывод заголовка из PROGMEM
//RT_HW_Base.printHeadPinsCols();                             //--Вывод параметров пинов в форме колонок;
RT_HW_Base.printHeadPinsRows();                               //--Вывод параметров пинов в форме строк;
RT_HW_Base.printHeadParamI2C();                               //--Вывод параметров i2c;
RT_HW_Base.printHeadScanI2C();                                //--Сканирование шины i2с;
RT_HW_Base.printHeadParamI2C();                               //--Вывод параметров i2c;
RT_HW_Base.printTextPGM(headUserPins_PGM,100, 'C', '=', 'Y'); //--Вывод заголовка из PROGMEM4;
RT_HW_Base.printDECx4(pinsTest_PGM,  30, 4, (int8_t)idCnt.pin, (int8_t)idTst1.pin, (int8_t)idTst2.pin, (int8_t)idTst3.pin); //--Вывод пинов;
RT_HW_Base.printDECx4(pinsLedBut_PGM,30, 3, (int8_t)idLed.pin, (int8_t)idBut.pin,  (int8_t)pinPot);                         //--Вывод пинов;
RT_HW_Base.printDECx4(pinsDAC_PGM,   30, 3, (int8_t)pinTCH,    (int8_t)pinPWM,     (int8_t)pinDAC);                         //--Вывод пинов;
RT_HW_Base.printBlank(80, '=', 'Y');
}
//-------------------------------------------------------------------------------------------------
//          БЫСТРАЯ  ЗАДАЧА =1 (вызов 1 раз в 100ms) 
//-------------------------------------------------------------------------------------------------
if (RT_HW_Base.shed.fast.num == 1) {
RT_HW_Base.pinReadADC(idPot,pinPot);
RT_HW_Base.pinReadTCH(idTCH,pinTCH);
RT_HW_Base.pinReadHALL(idHALL);
RT_HW_Base.pinWritePWM(idPWM,pinPWM,idPot.normal);
RT_HW_Base.pinWriteDAC(idDAC,pinDAC,idPot.normal);
RT_HW_Base.PrintUint16x4(idPrintADCx4,ADCx4_PGM, 4,idPot.filter, idPot.normal, idPWM.device,idDAC.device);
//RT_HW_Base.PrintInt16  (idPrintTCH,  RT_HW_PIN_NAME_KIND_TCH, idTCH.device,'Y');
//RT_HW_Base.PrintInt16x4(idPrintHALLx4,HALLx4_PGM,3,idHALL.filter,idHALL.normal);
}
//-------------------------------------------------------------------------------------------------
//          МЕДЛЕННАЯ ЗАДАЧА =1 (вызов 1 раз в секунду) [Вывод на консоль значений от 1 до 30]
//-------------------------------------------------------------------------------------------------
if (RT_HW_Base.shed.slow.num == 1) {
//  if(RT_HW_Base.printCheck()){cntPrint++; RT_HW_Base.printDEC(cntPrint,' '); if (cntPrint >= 30) { cntPrint = 0; RT_HW_Base.printCR();}}
}
//-------------------------------------------------------------------------------------------------
//          МЕДЛЕННАЯ ЗАДАЧА =2 (вызов 1 раз в секунду) [Заглушка]
//-------------------------------------------------------------------------------------------------
if (RT_HW_Base.shed.slow.num == 2) {;};
//------------------------------------------------------------------------------------------------
} //--End loop;
