/**************************************************************************************************
								БИБЛИОТЕКА RT_HW_BASE.h
 *************************************************************************************************/
#ifndef   RT_HW_BASE_h
#define   RT_HW_BASE_h
#define   RT_HW_BASE_VER 				02	//--Номер версии библиотеки
#include "RT_HW_BASE_10_PARAM_GENERAL.hpp"	//--Настроечные макросы и функции общие
#include "RT_HW_BASE_11_PARAM_ARCH.hpp"		//--Настроечные макросы и функции для архитектуры AVR,DUE,ESP8266,ESP32,STM32F
#include "RT_HW_BASE_12_FUNCTION.hpp"		//--Настроечные макросы и функции для архитектуры AVR,DUE,ESP8266,ESP32,STM32F
//=================================================================================================
//						Класс базовых функций RT_HW_BASE.h
//=================================================================================================
class RT_HW_BASE{
public:
//-------------------------------------------------------------------------------------------------
struct STRUCT_SHED_ADD	{uint8_t  num,cnt,qnt;};
struct STRUCT_DEPTH 	{uint8_t  sys,adc,adcNull,adcDrift,pwm,dac;}; 
struct STRUCT_I2C   	{int8_t   sda,scl; uint16_t freq; uint8_t state;};
struct STRUCT_PWM   	{uint16_t channel; uint16_t freq;};
//-------------------------------------------------------------------------------------------------
struct SHEDULER{STRUCT_SHED_ADD quick,fast,slow,back,frdm;uint8_t gen250; uint32_t timeStart10,timeStart25;
						uint8_t blink;uint8_t run;uint8_t cnt50:1,cnt100:3,cnt250:4;} shed; //--Данные для	диспетчера задач; 
struct DEVICE{STRUCT_DEPTH depth; STRUCT_I2C i2c; STRUCT_PWM pwm; int8_t led;} device;		//--Данные по устройствам;
struct CONSOLE{uint8_t dir; uint8_t cnt:4, ready:1,head:1,resetHead:1,mess:1;} console;		//--Данные консоли;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_BASE();	//--Конструктор
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Базовые функции работы со временем
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t getPastTime(uint32_t &timeBegin, uint32_t timeEnd);					//--Возвращает разницу между двумя временными точками. 
uint32_t getPastMs 	(uint32_t &timeBegin);										//--Возвращает прошедшее время в мс;
uint32_t getPastMcs	(uint32_t &timeBegin);										//--Возвращает прошедшее время в мкс; 
uint8_t	 timeOut	(uint32_t &timeBegin, uint32_t timeEnd, uint16_t timeMax);	//--Контроль тайм-аута;
uint8_t  timeOutMs	(uint32_t &timeBegin, uint16_t timeMax);					//--Контроль тайм-аута мс;
uint8_t  timeOutMcs	(uint32_t &timeBegin, uint16_t timeMax);					//--Контроль тайм-аута мкс;
uint8_t  period		(uint32_t &timeBegin, uint32_t timeEnd, uint32_t period);	//--Генерация события с точным поддержания периода и защитой от пропуска шага.
void 	 sheduler();															//--Диспетчер задач;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Базовые функции работы с консолью
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void printBegin(uint32_t speed=115200, bool permit=1); 							//--Инициализация консоли;
bool printCheck();																//--Контроль готовности консоли;
void printCR(char suff='~');													//--Перевод строки;
void printSuff (char suff);														//--Вывод суффикса: ='~' нет вывода; ='Y' перевод строки; =другой символ-вывод 'этого символа;
void printChar (char      v, char suff='~');									//--Вывод символа char;
void printInt16(int16_t   v, char suff='~'); 									//--Вывод числа int16_t;
void printUint16(uint16_t v, char suff='~');									//--Вывод числа uint16_t;
void printValMode(char mode, int16_t val,char suff='~');						//--Вывод числа int16_t или uint16_t;
void printFloat(float v, uint8_t point=1,char suff='~');						//--Вывод числа float;
void printDEC  (int16_t   v, char suff='~');									//--Вывод DEC с форм. от 2 знаков;
void printHEX  (uint16_t  v, char suff='~');									//--Вывод HEX с форм. от 2 знаков;	
void printBlank(uint8_t   n, char blank=' ',char suff='~');						//--Вывод n заполнителей blank;
void printBool (bool v,char sign0='-',char sign1='+',char suff='~'); 			//--Вывод bool;
void printStr  (String  ptr, char suff='~');									//--Вывод строковой переменной;
void printNameKindPin(uint8_t val);												//--Вывод текста по номеру текста; 
void printIntx4 (uint8_t qnt, int16_t v1=0, int16_t v2=0, int16_t v3=0, int16_t v4=0);			//--Вывод 4-х int16_t;
void printUintx4(uint8_t qnt, int16_t v1=0, int16_t v2=0, int16_t v3=0, int16_t v4=0);			//--Вывод 4-х uint16_t;
void printDECx4 (uint8_t qnt, int16_t v1=0, int16_t v2=0, int16_t v3=0, int16_t v4=0);			//--Вывод 4-х DEC;
void prinHEXx4	(uint8_t qnt, uint8_t v1=0, uint8_t v2=0, uint8_t v3=0, uint8_t v4=0);			//--Вывод 4-х HEX;
void printTextStr(String str,       uint8_t len=0,  char alig='L',char blank=' ',char suff='~');//--Вывод форматированный строковой переменной;
void printTextPGM(const char *text, uint8_t len=80, char alig='L',char blank=' ',char suff='~');//--Вывод форматированный строки из PROGMEM; 	
//------------------------------------------------------------------------------------------------- 	
void printHeadArchBoard();														//--Вывод наименований и кодов архитектуры и модели контроллера;	
void printHeadParamBoard();														//--Вывод параметров контроллера;
void printHeadPinsCols();														//--Вывод таблицы (колонки) пинов;
void printHeadPinsRows();														//--Вывод таблицы (строки) пинов;
void printHeadParamI2C();														//--Вывод параметров i2c;
void printHeadParamSPI();														//--Вывод параметров SPI;
void printHeadScanI2C();														//--Вывод результатов сканирования i2c;
//-------------------------------------------------------------------------------------------------
uint8_t getLenPGM   (const char *text, uint8_t lenMax);
uint8_t getLenStr   (String &str,      uint8_t lenMax);
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Всомогательные  функции работы с консолью
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool    checkChange(uint16_t* buff, uint16_t v1, uint16_t v2, uint16_t v3, uint16_t v4);//--Проверка изменения 4-х значений;
char    boolToChar (bool val, char sign_0='-',char sign_1='+');					//--Конвертация bool в char; 
uint8_t getLenBegin(uint8_t len, uint8_t src, char alig);						//--Кол-во заполнителей спереди; 
uint8_t getLenEnd  (uint8_t len, uint8_t src, char alig);						//--Кол-во заполнителей сзади;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	Функции работы c пинами через структуру
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int8_t   checkPinKind   (int8_t pin, uint8_t kind);								//--Проверка наличия пина;
uint8_t  calcQntKindPins(            uint8_t kind);								//--Возвращает кол-во пинов в группе;
uint16_t getModePin		(int8_t pin);											//--Получение слова свойств пина;
void 	 directPinSetID	(RT_HW_PIN_DIR_ID &id, int8_t pin); 					//--Настройка параметров пина - адрес регистра,маска,режим использования;
//-------------------------------------------------------------------------------------------------
// 	Функции вспомогательные
//-------------------------------------------------------------------------------------------------
uint8_t getFistBitUint16(uint16_t &reg);										//--Возвращает первый свободный бит регистра reg;
uint16_t maxBitDepth(uint8_t  v);  												//--Возвращает макс.число числа разрядности v;
uint16_t normADC  	(uint16_t v);												//--Нормализация прочитанного ADC значения;
uint16_t normPWM  	(uint16_t v);												//--Нормализация выводимого   PWM значения;
uint16_t normDAC  	(uint16_t v);												//--Нормализация выводимого   DAC значения;
uint16_t makeDelta  (uint16_t v1, uint16_t v2, uint8_t delta);					//--Получения значения при выходе за гистерезис
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Работа с пинами средствами Wiring
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++																						 
void pinReadDIN (RT_HW_PIN_DIN_ID  &id, int8_t pin, char spec='I', char inv='N', uint8_t periodRattigTick50=0);//--Чтение дискретного пина;
void pinReadADC (RT_HW_PIN_ADC_ID  &id, int8_t pin); 							//--Чтение аналогово пина;
void pinReadTCH (RT_HW_PIN_TCH_ID  &id, int8_t pin);							//--Чтение сенсорного пина (ESP32);
void pinReadHALL(RT_HW_PIN_HALL_ID &id);										//--Чтение датчика Холла;
void pinWriteDOT(RT_HW_PIN_DOT_ID  &id, int8_t pin, bool val, char open='N');	//--Запись DO;
void pinWritePWM(RT_HW_PIN_PWM_ID  &id, int8_t pin, uint16_t val, uint16_t freq=1000);	//--Запись PWM;
void pinWriteDAC(RT_HW_PIN_DAC_ID  &id, int8_t pin, uint16_t val);				//--Запись DAC;
//-------------------------------------------------------------------------------------------------
void beginI2C(int8_t sda=-1, int8_t scl=-1, uint16_t freq=0);
bool findDeviceI2C(RT_HW_FIND_I2C_ID &id, int8_t adr, uint8_t cntMax);
//-------------------------------------------------------------------------------------------------
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		LINK: РАБОТА С ИНТЕРФЕЙСАМИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
SPI_STM32
class SPISettings
SPISettings(uint32_t clock, BitOrder bitOrder, uint8_t dataMode) {}
SPISettings(uint32_t clock, BitOrder bitOrder, uint8_t dataMode, uint32_t dataSize){} 
SPISettings(uint32_t clock) 
SPISettings() { init_AlwaysInline(4000000, MSBFIRST, SPI_MODE0, DATA_SIZE_8BIT); }
    uint8 transfer(uint8 data) const;
    uint16_t transfer16(uint16_t data) const;
    uint8 dmaTransfer(const void * transmitBuf, void * receiveBuf, uint16 length);
    void dmaTransferSet(const void *transmitBuf, void *receiveBuf);
    uint8 dmaTransferRepeat(uint16 length);

void	i2c_init();
void	spi_begin();
void    HC595(uint8_t &dir, uint8_t &ago, uint8_t cs, uint8_t val){
switch(dir){
	case 0: if(!prim.spi) break; dir++;
	case 1:	pinMode(cs,OUTPUT); ago=val; digitalWrite(cs, LOW); SPI.transfer(val); digitalWrite(cs, HIGH);
			dir++; break;
	case 2: if(ago!=val) {ago=val; digitalWrite(cs, LOW); SPI.transfer(val); digitalWrite(cs, HIGH);} break;
}};
//--Вывод в 74HC595 через SPI
if(EN){ switch(dir) {	case 0: if( ((int8_t)cs <0)  || ((int8_t)cs >127) ) break; dir++;			//---Проверка на лопустимость номера пина
					case 1:	ago=val;  pinMode(cs,OUTPUT); digitalWrite(cs, HIGH); 
		    					 if( ИНИЦИАЛИЗИРОВАТЬ SPI =='Y') {SPI.begin();}			//--Инициализация шины;
							ago=val+1; dir++;
					case 2: if(ago!=val) {ago=val; digitalWrite(cs, LOW); SPI.transfer(val); digitalWrite(cs, HIGH);} break;}};
*/
//-------------------------------------------------------------------------------------------------
private:
uint32_t buff32;
};  //---END 
//-------------------------------------------------------------------------------------------------
//=================================================================================================
extern RT_HW_BASE 	RT_HW_Base; //--Создание объекта RT_HW_base;
//=================================================================================================
#endif //---RT_HW_BASE_h

