#include "RT_HW_BASE.h"
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Конструктор
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_BASE:: RT_HW_BASE(){//console.dir=0; console.begin=console.ready=console.head=console.mess=0; 
//---Настройка диспетчера задач ------------------------------------------------------------------
shed.cnt50=shed.cnt100=shed.cnt250=shed.gen250=0;
shed.quick.cnt=shed.fast.cnt=shed.slow.cnt=shed.back.cnt=shed.frdm.cnt=0;
shed.quick.qnt=5; 							//--Кол-во срочных   задач (период  10мс);
shed.fast.qnt=4;							//--Кол-во быстрых   задач (период  25мс);
shed.slow.qnt=4; 							//--Кол-во медленных задач (период 250мс);
shed.back.qnt=5;   							//--Кол-во фоновых   задач (период 100мс);
shed.frdm.qnt=20; 							//--Кол-во свободных задач (период loop()-когда нет вызванных задач);
shed.run=0;									//--Флаги разрешения запусков задач(quick,fast,slow,back,frdm);
//---Настройка рабочих регистров-------------------------------------------------------------------
device.led			 =RT_HW_PIN_LED; 		//--Номер контрольного пина; 	
device.depth.sys	 =RT_HW_SYS_DEPTH;		//--Установка системной разрядности устройств;
device.depth.adc	 =RT_HW_ADC_DEPTH; 		//--Разрешение ADC;	
device.depth.adcDrift=RT_HW_ADC_DRIFT; 		//--Допустимый дрейф нуля ADC;	
device.depth.adcNull =RT_HW_ADC_NULL; 		//--Допустимый дрейф текущих показаний ADC;	 
device.depth.pwm	 =RT_HW_PWM_DEPTH; 		//--Разрешение PWM;
device.depth.dac	 =RT_HW_DAC_DEPTH; 		//--Разрешение DAC;	
#if defined(RT_HW_ARCH_DUE) 
	analogReadResolution(device.depth.adc);	//--Настройка разрядности ADC для контроллера SAM3X8E (Arduino DUE); 
	analogWriteResolution(device.depth.pwm);//--Настройка разрядности PWM для контроллера SAM3X8E (Arduino DUE); 
#endif 
//---Настройка i2c---------------------------------------------------------------------------------
device.i2c.sda	=RT_HW_I2C_SDA;				//--
device.i2c.scl	=RT_HW_I2C_SCL;				//--
device.i2c.freq =RT_HW_I2C_FREQ;			//--
device.i2c.state=0;
//---Настройка SPI---------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Возврат прошедшего времени: timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее. 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint32_t RT_HW_BASE:: getPastTime(uint32_t &timeBegin, uint32_t timeEnd)   {if(timeEnd >= timeBegin) return (timeEnd-timeBegin); else return (0xFFFFFFFF-timeBegin+timeEnd);}; 
uint32_t RT_HW_BASE:: getPastMs	 (uint32_t &timeBegin){buff32=RT_HW_MILLIS; if(buff32  >= timeBegin) return (buff32 -timeBegin); else return (0xFFFFFFFF-timeBegin+buff32); };	
uint32_t RT_HW_BASE:: getPastMcs (uint32_t &timeBegin){buff32=RT_HW_MICROS; if(buff32  >= timeBegin) return (buff32 -timeBegin); else return (0xFFFFFFFF-timeBegin+buff32); };			
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  	Возврат 1 по тайм-ауту:     timeBegin -время начала отсчета (определяется вне функции); timeEnd-время текущее. 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t  RT_HW_BASE:: timeOut    (uint32_t &timeBegin, uint32_t timeEnd,   uint16_t timeMax){if(timeEnd>=timeBegin)  {if((timeEnd-timeBegin)>=timeMax) return 1; else return 0;} else {if((timeBegin-timeEnd)> timeMax) return 1; else return 0;}}; 
uint8_t  RT_HW_BASE:: timeOutMs  (uint32_t &timeBegin, uint16_t timeMax){buff32=RT_HW_MILLIS;if(buff32 >= timeBegin) {if((buff32 -timeBegin)>=timeMax) return 1; else return 0;} else {if((timeBegin-buff32) > timeMax) return 1; else return 0;}}; 
uint8_t  RT_HW_BASE:: timeOutMcs (uint32_t &timeBegin, uint16_t timeMax){buff32=RT_HW_MICROS;if(buff32 >= timeBegin) {if((buff32 -timeBegin)>=timeMax) return 1; else return 0;} else {if((timeBegin-buff32) > timeMax) return 1; else return 0;}}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	Функция генерит событие с точным поддержанием периода и защитой от пропуска шага. Идея от https://alexgyver.ru/arduino-algorithms/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t RT_HW_BASE:: period      (uint32_t &timeBegin, uint32_t timeEnd, uint32_t period){if((timeEnd-timeBegin)>=period) {do{timeBegin += period; if (timeBegin < period) break;} while (timeBegin < timeEnd - period); return 1;} return 0;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//										Диспетчер задач
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void 	RT_HW_BASE:: sheduler(){ 
shed.quick.num=shed.fast.num=shed.slow.num=shed.back.num=shed.frdm.num=0;
												shed.blink=shed.blink^1; 										//--бит 0 - loop()
if(period(shed.timeStart10,RT_HW_MICROS,10000)){shed.blink=shed.blink^0x02; bitSet(shed.run,0);}				//--бит 1 -  10мс
if(period(shed.timeStart25,RT_HW_MILLIS,25))   {shed.blink=shed.blink^0x04; bitSet(shed.run,1);					//--бит 2 -  25мс
 if(++shed.cnt250 >=10){shed.cnt250=0;          shed.blink=shed.blink^0x20; bitSet(shed.run,2); shed.gen250++;}	//--бит 5 - 250мс	
 if(++shed.cnt100 >= 4){shed.cnt100=0;	 		shed.blink=shed.blink^0x10; bitSet(shed.run,3);} 				//--бит 4 - 100мс
 if(shed.cnt50++  >= 1){shed.cnt50 =0;			shed.blink=shed.blink^0x08;} } 									//--бит 3 -  50мс			
//---Обработка вызова задач
if(shed.run){
 if(bitRead(shed.run,0)) {if(++shed.quick.cnt>shed.quick.qnt){shed.quick.cnt=1;} shed.quick.num=shed.quick.cnt; bitClear(shed.run,0); return;}
 if(bitRead(shed.run,1)) {if(++shed.fast.cnt >shed.fast.qnt) {shed.fast.cnt =1;} shed.fast.num =shed.fast.cnt;  bitClear(shed.run,1); return;}
 if(bitRead(shed.run,2)) {if(++shed.slow.cnt >shed.slow.qnt) {shed.slow.cnt =1;} shed.slow.num =shed.slow.cnt;  bitClear(shed.run,2); return;}
 if(bitRead(shed.run,3)) {if(++shed.back.cnt >shed.back.qnt) {shed.back.cnt =1;} shed.back.num =shed.back.cnt;  bitClear(shed.run,3); return;}}
				    else {if(++shed.frdm.cnt >shed.frdm.qnt) {shed.frdm.cnt =1;} shed.frdm.num =shed.frdm.cnt;                        return;}};													
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	Устанавливает параметры пина (номер регистра и маска)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BASE:: directPinSetID(RT_HW_PIN_DIR_ID &id,int8_t pin) {
if(id.mode==0){id.pin=pin; id.dir=7; id.mode=getModePin(pin);  bitSet(id.mode,15);	//--Установка флага "Пин обработан" 
if(bitRead(id.mode,RT_HW_PIN_KIND_DIR)) {RT_HW_PIN_DIR_SET_ID(id,id.pin);}}}; 		//--Установка параметров для пинов с прямым доступом;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	Проверяет принадлежность пина к группе с типом kind.Если нет, то возвращает -1, иначе возвращает номер пина.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
int8_t RT_HW_BASE:: checkPinKind(int8_t pin, uint8_t kind) {if(pin<0) {return -1;}; uint8_t p=pin;
if(kind==RT_HW_PIN_KIND_ALL) {return RT_HW_PIN_CHECK_ALL(p);}
if(kind==RT_HW_PIN_KIND_DIN) {return RT_HW_PIN_CHECK_DIN(p);}
if(kind==RT_HW_PIN_KIND_ADC) {return RT_HW_PIN_CHECK_ADC(p);}
if(kind==RT_HW_PIN_KIND_DOT) {return RT_HW_PIN_CHECK_DOT(p);}
if(kind==RT_HW_PIN_KIND_PWM) {return RT_HW_PIN_CHECK_PWM(p);}
if(kind==RT_HW_PIN_KIND_DAC) {return RT_HW_PIN_CHECK_DAC(p);}
if(kind==RT_HW_PIN_KIND_TCH) {return RT_HW_PIN_CHECK_TCH(p);}
if(kind==RT_HW_PIN_KIND_DIR) {return RT_HW_PIN_CHECK_DIR(p);}    
if(kind==RT_HW_PIN_KIND_INT) {return RT_HW_PIN_CHECK_INT(p);}
return -1;}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	Возвращает байт конфигурации пина
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE:: getModePin(int8_t pin) {int8_t x; uint16_t mode=0; if(pin<0) {return 0;};
for(uint8_t i=0;i<RT_HW_PIN_KIND_QNT;i++){for(uint8_t j=0;j<RT_HW_PIN_QNT_MAX;j++) {x=checkPinKind(j,i); if ((j==pin) && (x>=0)) {bitSet(mode,i);}}}  return mode;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	Возвращает кол-во пинов в группе;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t RT_HW_BASE:: calcQntKindPins(uint8_t kind){uint8_t qnt=0;for(uint8_t i=0; i<RT_HW_PIN_QNT_MAX; i++) {if(checkPinKind(i,kind)>=0) qnt++;} return qnt;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	 Утилиты
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint8_t  RT_HW_BASE::getFistBitUint16(uint16_t &reg){for(uint8_t i=0;i<=15;i++){if(!bitRead(reg,i)) return i;} return -1;};	 //--Возвращает первый свободный бит регистра reg;
uint16_t RT_HW_BASE::maxBitDepth(uint8_t  v){if(v>=16) {return 0xFFFF;} if(v==0){return 0;} return ((1<<v)-1);};			 //--Возвращает макс.число числа разрядности v;
uint16_t RT_HW_BASE::normADC  	(uint16_t v){return map(v,0,maxBitDepth(device.depth.adc),0,maxBitDepth(device.depth.sys));};//--Нормализация прочитанного ADC значения;
uint16_t RT_HW_BASE::normPWM  	(uint16_t v){return map(v,0,maxBitDepth(device.depth.sys),0,maxBitDepth(device.depth.pwm));};//--Нормализация выводимого   PWM значения;
uint16_t RT_HW_BASE::normDAC  	(uint16_t v){return map(v,0,maxBitDepth(device.depth.sys),0,maxBitDepth(device.depth.dac));};//--Нормализация выводимого   DAC значения;
uint8_t getLenStr(String &str, uint8_t lenMax);								//--
uint8_t getLenPGM(const char *text, uint8_t lenMax);						//--
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//	Возвращает входное значение с поправкой на гистериз изменения
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
uint16_t RT_HW_BASE:: makeDelta(uint16_t v1, uint16_t v2, uint8_t delta){
if(v2>v1) {if((v2-v1)>delta) {return v2;}} 
if(v1>v2) {if((v1-v2)>delta) {return v2;}} 
return v1;}  //--Гистерезис двух величин;
//---------------------------------------------------------------------------------------		
RT_HW_BASE RT_HW_Base;//--Создание внешнего объекта	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++