#include "RT_HW_BASE.h"	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//					Инициализация консоли
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printBegin(uint32_t speed, bool permit) {
if(console.dir==3) {return;}
if(console.dir==0) {if(permit) {Serial.begin(speed); console.dir++;} else {return;}}	//--Настройка Serial по внешнему разрешению permit
if(console.dir==1) {if(Serial) {printCR(); Serial.println(F("Console ON"));  console.cnt=0; console.ready=console.head=1; console.dir++;} else {return;}}; //--Ожидание готовности Serial (важно для DUE,STM32)
if(console.dir==2) {if((console.resetHead) || (++console.cnt>=10)) {console.head=0; console.mess=1; console.dir++;}};} //--Ожидание сброса или 10 циклов loop(); 		
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//					I.Простые функциии вывода на консоль
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//----------------Контроль готовности консоли------------------------------------------------------
bool RT_HW_BASE:: printCheck() { if(!console.ready) {if(Serial){console.ready=1;}} return console.ready;};
//----------------Перевод строки-------------------------------------------------------------------
void RT_HW_BASE:: printCR(char suff){ if(printCheck())  {printSuff(suff); Serial.write('\n');}};				
//----------------Вывод суффикса-------------------------------------------------------------------
void RT_HW_BASE:: printSuff(char suff){ if(printCheck()){if(suff=='~') {return;} if(suff=='Y') {Serial.write('\n'); return;}; if(suff=='s') {suff=' ';} Serial.write(suff);}}; 
//----------------Вывод символа char---------------------------------------------------------------
void RT_HW_BASE:: printChar(char v, char suff) {if(printCheck()){ Serial.write(v); printSuff(suff);}};
//----------------Вывод числа int------------------------------------------------------------------
void RT_HW_BASE:: printInt16(  int16_t v, char suff){if(printCheck()){ Serial.print(v); printSuff(suff);}};
//----------------Вывод числа int------------------------------------------------------------------
void RT_HW_BASE:: printUint16( uint16_t v, char suff){if(printCheck()){ Serial.print((uint16_t)v); printSuff(suff);}};	
//----------------Вывод числа float----------------------------------------------------------------
void RT_HW_BASE:: printFloat(float v,uint8_t point, char suff) {if(printCheck()){Serial.print(v,point); printSuff(suff);}};
//----------------Вывод DEC с форматированием от 2 знаков------------------------------------------
void RT_HW_BASE:: printDEC(int16_t val,char suff){if(printCheck()){if((val>=0)&&(val<10)){Serial.write(' ');} Serial.print(val,DEC);printSuff(suff);}};
//----------------Вывод HEX с форматированием от 2 знаков------------------------------------------
void RT_HW_BASE:: printHEX(uint16_t val,char suff){if(printCheck()){Serial.write('0');Serial.write('x');if(val<16){Serial.write('0');} Serial.print(val,HEX); printSuff(suff);}};
//----------------Вывод n заменителей--------------------------------------------------------------	
void RT_HW_BASE:: printBlank(uint8_t n,char blank,char suff) {if(printCheck()){if(blank==RT_HW_CODE_CHAR_BLANK) {blank=' ';} for(int i=0; i<n; i++){Serial.write(blank);} printSuff(suff);}}; 	
//----------------Вывод bool-----------------------------------------------------------------------
void RT_HW_BASE:: printBool(bool v,char sign0,char sign1,char suff){if(printCheck()){if(v) {Serial.write(sign1);} else {Serial.write(sign0);} printSuff(suff);}};
//----------------Вывод числа в формате int16_t или uint16_t---------------------------------------
void RT_HW_BASE:: printValMode(char mode, int16_t val, char suff){if(printCheck()) {if(mode=='I') {printDEC(val);} else {printDEC((uint16_t)val);} printSuff(suff);}};
//----------------Вывод строковой переменной-------------------------------------------------------
void RT_HW_BASE:: printStr(String val,char suff){if(printCheck()){Serial.print(val); printSuff(suff);}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//					Форматированный вывод строковой переменной
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printTextStr(String str, uint8_t len, char alig, char blank, char suff) { if(printCheck()) {uint8_t curLen=0;  
if(len>0) {str.substring(0,len);} curLen=str.length();               
printBlank(getLenBegin(len,curLen,alig),blank); printStr(str); printBlank(getLenEnd(len,curLen,alig),blank); printSuff(suff); }};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//					Форматированный вывод текста из PROGMEM
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printTextPGM(const char *text, uint8_t len, char alig, char blank, char suff) { if(printCheck()) {uint8_t curLen=getLenPGM(text,len);                     
printBlank(getLenBegin(len,curLen,alig),blank); 
for(uint8_t i=0;i<len;i++){char vChar=pgm_read_byte(text+i); if((vChar=='\0') || (vChar==RT_HW_CODE_CHAR_BREAK)){break;} Serial.write(vChar);}
printBlank(getLenEnd(len,curLen,alig),blank); printSuff(suff);}};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  Вывод 4-х int16;	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_BASE:: printIntx4(uint8_t qnt, int16_t v1, int16_t v2, int16_t v3, int16_t v4){if(printCheck()){
if(qnt>0){ 					Serial.print(v1);}	
if(qnt>1){printChar(','); 	Serial.print(v2);} 
if(qnt>2){printChar(','); 	Serial.print(v3);} 
if(qnt>3){printChar(','); 	Serial.print(v4);} 
printChar(';','Y'); }};	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  Вывод 4-х uint16;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_BASE:: printUintx4(uint8_t qnt, int16_t v1, int16_t v2, int16_t v3, int16_t v4){if(printCheck()){
if(qnt>0){ 					Serial.print((uint16_t)v1);}	
if(qnt>1){printChar(','); 	Serial.print((uint16_t)v2);} 
if(qnt>2){printChar(','); 	Serial.print((uint16_t)v3);} 
if(qnt>3){printChar(','); 	Serial.print((uint16_t)v4);} 
printChar(';','Y'); }};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  Вывод 4-х DEC (с добавлением пробела, если v<10;	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_BASE:: printDECx4(uint8_t qnt, int16_t v1, int16_t v2, int16_t v3, int16_t v4){if(printCheck()){
if(qnt>0){ 					printDEC(v1);}	
if(qnt>1){printChar(','); 	printDEC(v2);} 
if(qnt>2){printChar(','); 	printDEC(v3);} 
if(qnt>3){printChar(','); 	printDEC(v4);} 
printChar(';','Y'); }};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  Вывод по изменению значениq uint16 x 4 (с заголовком и и суффиксом);	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_BASE:: prinHEXx4(uint8_t qnt, uint8_t v1, uint8_t v2, uint8_t v3, uint8_t v4){if(printCheck()){
if(qnt>0){ 					printHEX(v1);}	
if(qnt>1){printChar(','); 	printHEX(v2);} 
if(qnt>2){printChar(','); 	printHEX(v3);} 
if(qnt>3){printChar(','); 	printHEX(v4);} 
printChar(';','Y'); }};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						II. ВСПОМОГАТЕЛЬНЫЕ ФУНКЦИИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char    RT_HW_BASE::boolToChar (bool val,char sign_0,char sign_1){if(val) return sign_1; else return sign_0;};		//--Конвертация bool в char; 
//-------------------------------------------------------------------------------------------------
uint8_t RT_HW_BASE::getLenBegin(uint8_t len,uint8_t src,char alig){if(len<=src) return 0;switch(alig){default:return 0;case 'C':return (len-src-(len-src)/2);              case 'R':return (len-src);}}; //--Кол-во заполнителей спереди; 
//-------------------------------------------------------------------------------------------------
uint8_t RT_HW_BASE::getLenEnd  (uint8_t len,uint8_t src,char alig){if(len<=src) return 0;switch(alig){default:return 0;case 'C':return (len-src-getLenBegin(len,src,alig));case 'L':return (len-src);}}; //--Кол-во заполнителей сзади;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		2.1. Возвращает длину String  в формате utf-8 (с учетом блокирующего символа RT_HW_CODE_CHAR_BREAK '~')
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE:: getLenStr(String &str, uint8_t lenMax){uint8_t buff,j,LEN; if(lenMax==0) {lenMax=40;} j=LEN=0;
for(uint8_t i=0; i<lenMax;i++){buff=str.charAt(j);        if((buff==0) || (buff==RT_HW_CODE_CHAR_BREAK)) {return LEN;} LEN++; j++; if(buff>=0xC0) {j++;}}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		2.2. Возвращает длину текста из PROGMEM  в формате utf-8 c с учетом символа RT_HW_CODE_CHAR_BREAK '~'
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t RT_HW_BASE:: getLenPGM(const char *text, uint8_t lenMax){uint8_t buff,j,LEN; if(lenMax==0) {lenMax=40;} j=LEN=0;
for(uint8_t i=0; i<lenMax;i++){buff=pgm_read_byte(text+j); if((buff==0) || (buff==RT_HW_CODE_CHAR_BREAK)) {return LEN;} LEN++; j++; if(buff>=0xC0) {j++;}}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//					III.Функциии вывода на консоль параметров контроллера
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.1.Вывод наименований и кодов архитектуры и модели контроллера
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printHeadArchBoard(){ if(printCheck()){
	Serial.print(F("ARCH="));  Serial.print(F(RT_HW_ARCH_NAME));  printChar('/'); printInt16(RT_HW_ARCH_CODE,';'); printBlank(2);  
	Serial.print(F("BOARD=")); Serial.print(F(RT_HW_BOARD_NAME)); printChar('/'); printInt16(RT_HW_BOARD_CODE,';');printBlank(2);
	Serial.print(F("Fcpu="));  printInt16(RT_HW_FCPU,';'); printBlank(2);
	Serial.print(F("Led="));   printInt16(device.led,';'); printBlank(2);
	Serial.print(F("Lib="));   printFloat((RT_HW_BASE_VER/(float)10),1,';');	printCR();}};  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.2.Вывод имени типа пина
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printNameKindPin(uint8_t val){
if(val==RT_HW_PIN_KIND_ALL) {Serial.print(F("ALL")); return;}	
if(val==RT_HW_PIN_KIND_DIN) {Serial.print(F("DIN")); return;}
if(val==RT_HW_PIN_KIND_ADC) {Serial.print(F("ADC")); return;}
if(val==RT_HW_PIN_KIND_DOT) {Serial.print(F("DOT")); return;}
if(val==RT_HW_PIN_KIND_PWM) {Serial.print(F("PWM")); return;}
if(val==RT_HW_PIN_KIND_DAC) {Serial.print(F("DAC")); return;}
if(val==RT_HW_PIN_KIND_TCH) {Serial.print(F("TCH")); return;}	
if(val==RT_HW_PIN_KIND_DIR) {Serial.print(F("DIR")); return;}	
if(val==RT_HW_PIN_KIND_INT) {Serial.print(F("INT")); return;} 
Serial.print(F("-"));};				
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.3. Вывод пинов в колонках //--printStrPGM(getAdrNameKind(j));
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printHeadPinsCols(){ if(printCheck()) { uint16_t mode;
printBlank(45,'-','\n');
Serial.print(F("PIN")); for(int i=0; i<RT_HW_PIN_KIND_QNT; i++) {printBlank(1); printNameKindPin(i);} printCR();	//--printStrPGM(getAdrNameKind(i));   
printBlank(3,'*',' ');  for(int i=0; i<RT_HW_PIN_KIND_QNT; i++) {printBlank(1); printDEC(calcQntKindPins(i),' ');} printCR();
printBlank(45,'-','\n');
for(uint8_t i=0; i<RT_HW_PIN_QNT_MAX;  i++){mode=getModePin(i); if(mode){printBlank(1); printDEC(i); 
for(uint8_t j=0; j<RT_HW_PIN_KIND_QNT; j++){if(bitRead(mode,j)) {printBlank(1); printNameKindPin(j);}
else{printBlank(1); printBlank(3,'-');}}  printBlank(1); printHEX(mode); printCR();}} printBlank(45,'-','\n'); }};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.4. Вывод пинов в строках	//--printStrPGM(getAdrNameKind(i)); 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printHeadPinsRows(){ if(printCheck()) {uint16_t mode, qnt, cnt; bool cr=0;
for(int i=0; i<RT_HW_PIN_KIND_QNT; i++){ cnt=0; qnt=calcQntKindPins(i); 
if(qnt>0){printNameKindPin(i); printChar('['); printDEC(qnt); printChar(']'); printChar(':',' ');
for(uint8_t j=0; j<RT_HW_PIN_QNT_MAX;  j++){mode=getModePin(j); if(bitRead(mode,i)) {if(cr){cr=0; printCR(); printBlank(9);} printDEC(j,' '); if(++cnt>=30) {cr=1; cnt=0;};}} printCR();}}}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.4 Вывод разрешения SYS,ADC,PWM,DAC
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: printHeadParamBoard(){ if(printCheck()){
Serial.print(F("DEPTH:")); printBlank(2);
Serial.print(F("SYS="));   printInt16(device.depth.sys,';'); printBlank(2);
Serial.print(F("ADC(depth,null,drift)=")); printInt16(device.depth.adc,','); printInt16(device.depth.adcNull,','); printInt16(device.depth.adcDrift,';'); printBlank(2);
Serial.print(F("PWM="));   printInt16(device.depth.pwm,';');  printBlank(2);
if(device.depth.dac>0) {Serial.print(F("DAC=")); printInt16(device.depth.dac,';');}; printCR();}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.4. Вывод параметров шины i2с
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++};	
void RT_HW_BASE:: printHeadParamI2C(){ if(printCheck()){Serial.print(F("i2c: sda,scl,freq,state="));
printInt16(device.i2c.sda,','); printInt16(device.i2c.scl,','); printInt16(device.i2c.freq,','); printInt16(device.i2c.state,';'); printCR();}}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.6. Вывод параметров шины SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++};	
void RT_HW_BASE:: printHeadParamSPI(){ if(printCheck()){Serial.print(F("SPI: SS,MOSI,MISO,SCK="));
printInt16(RT_HW_SPI_SS,','); printInt16(RT_HW_SPI_MOSI,','); printInt16(RT_HW_SPI_MISO,','); printInt16(RT_HW_SPI_SCK,';'); printCR();}}; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//			3.7. Сканирование шины i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE::printHeadScanI2C(){ if(printCheck()){ uint8_t qnt=0;
beginI2C(); Serial.print(F("i2c->="));  
for(int i=1;i<128;i++){Wire.beginTransmission(i); if(!Wire.endTransmission()){if(qnt){printChar(',');} qnt++; printHEX(i,'/'); printUint16(i);}}		
printChar(';','Y'); printChar('q','n'); printChar('t','='); printInt16(qnt,';'); printCR();}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


		   
