#include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Интерфейс i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_DUE)
void RT_HW_BASE:: beginI2C(int8_t sda, int8_t scl, uint16_t freq){ if(device.i2c.state==1) return;
if(sda>=0){device.i2c.sda=sda;}  if(scl>=0){device.i2c.scl=scl;} if(freq>=10){device.i2c.freq=freq;} 
Wire.begin(); 
Wire.setClock((device.i2c.freq*(uint32_t)1000));
device.i2c.state=1; };
//-----------------------------------------------------------------------------
#elif 	defined(RT_HW_ARCH_ESP8266) 	
void RT_HW_BASE:: beginI2C(int8_t sda, int8_t scl, uint16_t freq){ if(device.i2c.state==1) return;
if(sda>=0){device.i2c.sda=sda;}  if(scl>=0){device.i2c.scl=scl;} if(freq>=10){device.i2c.freq=freq;} 
Wire.begin(device.i2c.sda, device.i2c.scl, (device.i2c.freq*(uint32_t)1000)); 
Wire.setClockStretchLimit(260); 
device.i2c.state=1; }; 	
//-----------------------------------------------------------------------------		
#elif  defined(RT_HW_ARCH_ESP32) 
void RT_HW_BASE:: beginI2C(int8_t sda, int8_t scl, uint16_t freq){ if(device.i2c.state==1) return;
if(sda>=0){device.i2c.sda=sda;}  if(scl>=0){device.i2c.scl=scl;} if(freq>=10){device.i2c.freq=freq;} 
Wire.begin(device.i2c.sda, device.i2c.scl, (device.i2c.freq*(uint32_t)1000)); 
device.i2c.state=1;	};
//-----------------------------------------------------------------------------
#elif defined(RT_HW_ARCH_STM32F1) 
void RT_HW_BASE:: beginI2C(int8_t sda, int8_t scl, uint16_t freq){ if(device.i2c.state==1) return;
if(sda>=0){device.i2c.sda=sda;}  if(scl>=0){device.i2c.scl=scl;} if(freq>=10){device.i2c.freq=freq;} 
Wire.begin(); 
Wire.setClock(device.i2c.freq * (uint32_t)1000); 
device.i2c.state=1; };	
//-----------------------------------------------------------------------------
#else
void RT_HW_BASE:: beginI2C(int8_t sda, int8_t scl, uint16_t freq){}; 
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Интерфейс SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_ARCH_STM32F1) 
#else
//void RT_HW_BASE:: beginSPI(){SPI.begin();}; 
#endif




/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Инициирование интерфейса i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: beginI2C(int8_t sda, int8_t scl, uint16_t freq){ if(device.i2c.state==1) return;
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_DUE)
if(sda>=0){device.i2c.sda=sda;}  if(scl>=0){device.i2c.scl=scl;} if(freq>=10){device.i2c.freq=freq;} 
Wire.begin(); Wire.setClock((device.i2c.freq*(uint32_t)1000));device.i2c.state=1;
//-----------------------------------------------------------------------------
#elif 	defined(RT_HW_ARCH_ESP8266) 	
if(sda>=0){device.i2c.sda=sda;}  if(scl>=0){device.i2c.scl=scl;} if(freq>=10){device.i2c.freq=freq;} 
Wire.begin(device.i2c.sda, device.i2c.scl, (device.i2c.freq*(uint32_t)1000)); Wire.setClockStretchLimit(260); device.i2c.state=1;	
//-----------------------------------------------------------------------------		
#elif  defined(RT_HW_ARCH_ESP32) 
if(sda>=0){device.i2c.sda=sda;}  if(scl>=0){device.i2c.scl=scl;} if(freq>=10){device.i2c.freq=freq;} 
Wire.begin(device.i2c.sda, device.i2c.scl, (device.i2c.freq*(uint32_t)1000)); device.i2c.state=1;	
//-----------------------------------------------------------------------------
#elif defined(RT_HW_ARCH_STM32F1) 
if(sda>=0){device.i2c.sda=sda;}  if(scl>=0){device.i2c.scl=scl;} if(freq>=10){device.i2c.freq=freq;} 
Wire.begin(); Wire.setClock(device.i2c.freq * (uint32_t)1000); device.i2c.state=1;	
#endif
};

*/
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Инициирование интерфейса i2c
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++





//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		Вспомогательные функции 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++};	


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  ПОИСК УСТРОЙСТВА НА ШИНЕ i2c 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
bool RT_HW_BASE::findDeviceI2C(RT_HW_FIND_I2C_ID &id, int8_t adr, uint8_t cntMax){
//uint8_t &step, uint8_t &cnt, uint16_t &period, uint32_t &timeDelay,  int8_t adr, uint8_t cntMax){
if(id.dir==0) {if(adr<0) return 0; id.cnt=0; id.period=0; id.timeDelay=RT_HW_MILLIS; id.dir=1;}
if(id.dir==1) {id.timeDelay=RT_HW_MILLIS; id.dir=2;}
if(id.dir==2) {if(!((RT_HW_MILLIS-id.timeDelay)>id.period)) {return 0;} //--Ожидание задержки по времени;
		       id.cnt++; if(id.cnt>=cntMax) id.cnt=cntMax; 				//--Ограничение счетчика сверху;
		       Wire.beginTransmission(adr);								//--Запрос на шину i2c
			   if(Wire.endTransmission()==0){id.period= 50; if(id.cnt <2){id.dir=1; return 0;} else {id.dir=0; return 1;}}
			                           else {id.period=100*id.cnt;        id.dir=1; return 0;}}; //--Выход для повторного поиска
id.dir=0; return 0;};				
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++};
	