#include "RT_HW_BASE.h"	 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  ЧТЕНИЕ С ДИСКРЕТНОГО ПИНА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: pinReadDIN(RT_HW_PIN_DIN_ID &id, int8_t pin, char spec, char inv, uint8_t periodRattigTick50){
if(id.dir==0) {uint16_t mode=getModePin(pin); 
			   if(bitRead(mode,RT_HW_PIN_KIND_DIN) && ((spec=='I') || (spec=='U') || (spec=='D') || (spec=='F'))){
				if(spec=='I') {pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--дискретный вход обычный;
				if(spec=='U') {pinMode(pin, RT_HW_PIN_MODE_INPUT_PULLUP);}	//--дискретный вход с подтяжкой к +Vcc;
				if(spec=='D') {pinMode(pin, RT_HW_PIN_MODE_INPUT_PULLDOWN);}//--с подтяжкой к Gnd;											
				if(spec=='F') {pinMode(pin, RT_HW_PIN_MODE_INPUT);}			//--дискретный вход - аналог INPUT; 	
				id.device=id.filter=digitalRead(pin); 
				if(inv=='Y') {id.normal=!id.filter;} else {id.normal=id.filter;};
				if(periodRattigTick50){id.dir=2;}    else {id.dir=1;}}
			   else {id.normal=id.device=id.filter=0;      id.dir=7;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==1) {id.device=id.filter=digitalRead(pin); if(inv=='Y') {id.normal=!id.filter;} else {id.normal=id.filter;};}	 //--Чтение без защиты от дребезга;
//-------------------------------------------------------------------------------------------------
if(id.dir==2){id.device=digitalRead(pin); id.curBlink=bitRead(shed.blink,3); //--Сохраняем текущее значение пина и blink=50ms;
if(!id.step) {if(id.ago==id.device) {id.filter=id.device;} else {id.cnt=0; id.agoBlink=id.curBlink; id.step=1;}}
if(id.step)  {if(id.ago==id.device) {id.filter=id.device; id.step=0;} else {if(id.agoBlink!=id.curBlink) {
				id.agoBlink=id.curBlink; if(++id.cnt>=periodRattigTick50) {id.ago=id.filter=id.device; id.step=0;}}}}
			  if(inv=='Y') {id.normal=!id.filter;} else {id.normal=id.filter;};}
//-------------------------------------------------------------------------------------------------
}; //--Завершение обработки;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//				ЧТЕНИЕ С ADC ПИНА 
//(id.sensor-сенсор, id.filter-отфильтрованный id.sensor, id.normal-нормализованный id.filter)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: pinReadADC(RT_HW_PIN_ADC_ID &id, int8_t pin){
if(id.dir==0){uint16_t mode=getModePin(pin); if(!bitRead(mode,RT_HW_PIN_KIND_ADC)) { id.dir=7; id.device=id.filter=id.normal=0; return;}
			pinMode(pin,RT_HW_PIN_MODE_INPUT_ANALOG); id.dir=1;}		
if(id.dir==1) {uint16_t m16=maxBitDepth(device.depth.adc); 				  
			id.device=analogRead(pin); if(id.device>m16) {id.device=m16;} //--Сохраняем в буфере максимальное для ADC значение;
			id.filter=makeDelta(id.filter,id.device,device.depth.adcDrift); if(id.filter>m16) {id.filter=m16;} 
			if((m16-id.filter)<device.depth.adcDrift) {id.filter=m16;}
			if(id.filter<device.depth.adcNull) {id.filter=0;}	 
			id.normal=normADC(id.filter);}};	 									 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                  ЧТЕНИЕ С СЕНСОРНОГО ПИНА
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void RT_HW_BASE:: pinReadTCH(RT_HW_PIN_TCH_ID &id, int8_t pin){
#if  defined(RT_HW_ARCH_ESP32) 
if(id.dir==0) {uint16_t mode=getModePin(pin); if(!bitRead(mode,RT_HW_PIN_KIND_TCH)) {id.dir=7; return;} pinMode(pin,RT_HW_PIN_MODE_INPUT);id.dir=1;}		
if(id.dir==1) {id.device=id.filter=id.normal=touchRead(pin);
}		
#else 
id.dir=pin=-1; id.device=id.filter=id.normal=0;
#endif  
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ЧТЕНИЕ ВСТРОЕННОГО ДАТЧИКА ХОЛЛА [ESP32]
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void  RT_HW_BASE:: pinReadHALL(RT_HW_PIN_HALL_ID &id){
#if  defined(RT_HW_ARCH_ESP32) 
if(id.dir==0) {id.device=id.filter=id.normal=0; id.dir=1;}		
if(id.dir==1) {id.device=hallRead();};	
#else	
id.device=0;	
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ДИСКРЕТНЫЙ ВЫВОД 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void  RT_HW_BASE:: pinWriteDOT(RT_HW_PIN_DOT_ID &id, int8_t pin, bool val, char open){
if(id.dir==0) {uint16_t mode=getModePin(pin); if(!bitRead(mode,RT_HW_PIN_KIND_DOT)) {id.dir=7; return;}
			   if(open=='Y') {pinMode(pin, RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN);} else {pinMode(pin, RT_HW_PIN_MODE_OUTPUT);} id.dir=1;} 
if(id.dir==1) {digitalWrite(pin,val);}};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ШИМ ВЫВОД  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BASE:: pinWritePWM (RT_HW_PIN_PWM_ID &id, int8_t pin, uint16_t val, uint16_t freq){
	
//-----------------------------------------------------------------------------
if(id.dir==0) {id.freq=freq; if(id.freq==0) {id.freq=1000;} 
               uint16_t mode=getModePin(pin); if(!bitRead(mode,RT_HW_PIN_KIND_PWM)) {id.device=0; id.dir=7; return;}}; 
//-----------------------------------------------------------------------------
#if defined(RT_HW_ARCH_AVR) || defined(RT_HW_ARCH_DUE)

if(id.dir==0) {//pinMode(pin,RT_HW_PIN_MODE_OUTPUT); 
id.dir=1;}		//--Настройка;
if(id.dir==1) {id.device=normPWM(val); //id.device=240;  
analogWrite(pin,id.device);
}	//--Вывод ШИМ;

//-----------------------------------------------------------------------------
#elif 	defined(RT_HW_ARCH_ESP8266) 	
if(id.dir==0) {pinMode(pin,RT_HW_PIN_MODE_OUTPUT); 
         analogWriteFreq(constrain(id.freq, 100,10000)); id.dir=1;}	//--Настройка ШИМ;
if(id.dir==1) {id.device=normPWM(val); analogWrite(pin,id.device);}	//--Вывод ШИМ;		
//-----------------------------------------------------------------------------		
#elif  defined(RT_HW_ARCH_ESP32) 
if(id.dir==0){int16_t buff=getFistBitUint16(device.pwm.channel);	//--Получение номера свободного каналов PWM(переменная pwmChannelFlag);
	if(buff<0){id.device=0; id.dir=7; return;} 						//--Если все каналы заняты(num<0), выход со сбросом флага id.ok;
	id.num=buff; bitSet(device.pwm.channel,id.num);    				//--Установка флага занятости канала;
	ledcSetup(id.num,constrain(id.freq,100,40000),device.depth.pwm);//--Настройка канала id.channel: частота и разрешение;
	ledcAttachPin(pin,id.num);	id.dir=1;}		    				//--Настройка ШИМ ;
if(id.dir==1){id.device=normPWM(val); ledcWrite(id.num,id.device);}	//--Вывод ШИМ;
//-----------------------------------------------------------------------------
#elif defined(RT_HW_ARCH_STM32F1) 
if(id.dir==0) {pinMode(pin,RT_HW_PIN_MODE_OUTPUT); id.dir=1;}		//--Настройка;
if(id.dir==1) {id.device=normPWM(val); pwmWrite(pin,id.device);}	//--Вывод ШИМ;	
#endif
//-----------------------------------------------------------------------------

};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
//					ВЫВОД DAC
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
void RT_HW_BASE:: pinWriteDAC(RT_HW_PIN_DAC_ID &id, int8_t pin, uint16_t val){
//-----------------------------------------------------------------------------
#if defined(RT_HW_ARCH_DUE) 
if(id.dir==0) {if(!bitRead(getModePin(pin),RT_HW_PIN_KIND_DAC)){id.device=0; id.dir=7; return;} id.dir=1;}; 
if(id.dir==1) {id.device=normDAC(val); analogWrite(pin,id.device);}
//-----------------------------------------------------------------------------		
#elif  defined(RT_HW_ARCH_ESP32) 
if(id.dir==0) {if(!bitRead(getModePin(pin),RT_HW_PIN_KIND_DAC)){id.device=0; id.dir=7; return;} pinMode(pin,RT_HW_PIN_MODE_INPUT); id.dir=1;}; 
if(id.dir==1) {id.device=normDAC(val); dacWrite(pin,id.device);}
//-----------------------------------------------------------------------------
#elif 	defined(RT_HW_ARCH_STM32F1) 
if(id.dir==0) {if(!bitRead(getModePin(pin),RT_HW_PIN_KIND_DAC)){id.device=0; id.dir=7; return;} pinMode(pin,RT_HW_PIN_MODE_INPUT); id.dir=1;}; 
if(id.dir==1) {id.device=normDAC(val);  //analogWrite(pin,id.device);
			  };	//--Вывод;	
#else
if(pin<0) {id.device=val;} id.device=0;
#endif
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	



