//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//										МАКРОСЫ ДЛЯ ВСЕХ АРХИТЕКТУР
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
//										Общие функции
//-------------------------------------------------------------------------------------------------
#define RT_HW_BASE_DEPTH_SYS			12						//--Системная разрядность для нормализация устройств ADC,PWM,DAC;
//*************************************************************************************************
//								I. ПЛАТФОРМА AVR
//*************************************************************************************************
#if	defined(RT_HW_ARCH_AVR)
//-------------------------------------------------------------------------------------------------
//								1.1.Дополнительные библиотеки
//-------------------------------------------------------------------------------------------------
#include <Wire.h>												//--Подключение библиотеки i2c;	   	
#include <SPI.h>												//--Подключение библиотеки SPI
#include <SoftwareSerial.h>										//--Программный UART;
																//--Библиотека PROGMEM подключается ниже (под тип контроллера);	
//-------------------------------------------------------------------------------------------------
//		                       	1.2.Макросы для работы c пинами через функции WIRING  
//-------------------------------------------------------------------------------------------------
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT			//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT			//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  		OUTPUT			//--Дискретный выход с открытым стоком;
#define RT_HW_PIN_MODE_OUTPUT_PWM  				OUTPUT			//--ШИМ выход;
#define RT_HW_PIN_MODE_OUTPUT_PWM_OPEN_DRAIN 	OUTPUT			//--ШИМ выход с открытым коллектором;
//-------------------------------------------------------------------------------------------------
//		                       	1.3 Пины и параметры контроллеров
//-------------------------------------------------------------------------------------------------
//===============================Контроллеры типа Arduino UNO,Nano=================================
#if   defined(RT_HW_BOARD_AVR328) 
#include <avr/pgmspace.h>											//--Подключение библиотеки PROGMEM	
//------Параметры---------------------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=22,	RT_HW_PIN_LED=13,  RT_HW_SYS_DEPTH=12,  RT_HW_FCPU=16};
enum{RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4, RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=8, RT_HW_DAC_DEPTH=0}; 
enum{RT_HW_PERMIT_SS=1,	 	RT_HW_SS_RX=8,	   RT_HW_SS_TX=9,		RT_HW_SS_SPEEd=9600};
enum{RT_HW_PERMIT_I2C=1, 	RT_HW_I2C_SDA=18,  RT_HW_I2C_SCL=19,	RT_HW_I2C_FREQ=400};
enum{RT_HW_PERMIT_SPI=1, 	RT_HW_SPI_SS=10,   RT_HW_SPI_MOSI=11,	RT_HW_SPI_MISO=12,	RT_HW_SPI_SCK=13};
//------Макросы проверки пинов---------------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)<22)               ? (p):(-1)) //--Пин любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  ((p)>=2 && (p)<22       ? (p):(-1)) //--Пин типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)>=14) && ((p)<22)  ? (p):(-1)) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define RT_HW_PIN_CHECK_PWM(p)  (digitalPinHasPWM(p)    ? (p):(-1)) //--Пин типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1) 								//--Пин типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Пин типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1))	//--Пин типа DIR(допускается прямое управление)
#define RT_HW_PIN_CHECK_INT(p)  digitalPinToInterrupt(p)			//--Пин типа DIR(допускается прямое управление)
//==============================Контроллеры типа Arduino MEGA2560==================================
#elif   defined(RT_HW_BOARD_MEGA2560)																
//#include <avr/pgmspace.h>			//--Подключение библиотеки PROGMEM с корректировкой  для MEGA2560 выполнено ранее (RT_HW_BASE_10_PARAM_GENERAL.hpp)
//------Корректировка макросов для работы с PROGMEM------------------------------------------------
#undef	RT_HW_READ_BYTE_PGM
#define RT_HW_READ_BYTE_PGM(arr,n) 	pgm_read_byte(&arr[n])	//--Чтение из массива arr байта с номером n(для >64 kB);
//------Параметры---------------------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=70,	RT_HW_PIN_LED=13,  RT_HW_SYS_DEPTH=12,  RT_HW_FCPU=16};
enum{RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4, RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=8, RT_HW_DAC_DEPTH=0}; 
enum{RT_HW_PERMIT_SS=1,	 	RT_HW_SS_RX=68,	   RT_HW_SS_TX=69,		RT_HW_SS_SPEEd=9600};
enum{RT_HW_PERMIT_I2C=1, 	RT_HW_I2C_SDA=20,  RT_HW_I2C_SCL=21,	RT_HW_I2C_FREQ=400};
enum{RT_HW_PERMIT_SPI=1, 	RT_HW_SPI_SS=53,   RT_HW_SPI_MOSI=51,	RT_HW_SPI_MISO=50,	RT_HW_SPI_SCK=52};
//------Используемые макросы-----------------------------------------------------------------------
#define RT_HW_PIN_LED			13									//--Номер пина со светодиодом;
#define RT_HW_PIN_QNT_MAX		70									//--Максимальное кол-во пинов;
//------Макрос номера пина светодиода на плате-----------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)<70)               ? (p):(-1)) //--Пин любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)>=2)  && ((p)<70)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)>=54) && ((p)<70)  ? (p):(-1)) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)>=2)  && ((p)<70)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define RT_HW_PIN_CHECK_PWM(p)  (digitalPinHasPWM(p)    ? (p):(-1)) //--Пин типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1) 								//--Пин типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Пин типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)>=2)  && ((p)<54)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)
#define RT_HW_PIN_CHECK_INT(p)  digitalPinToInterrupt(p)			//--Номер прерывания по номеру пина
//===============================Другие контроллеры платформы AVR==================================
#else																//--Контроллеры AVR не опознанного типа;
#include <avr/pgmspace.h>											//--Подключение библиотеки PROGMEM	
//------Параметры---------------------------------------------------------------------------------	
enum{RT_HW_PIN_QNT_MAX=70,	RT_HW_PIN_LED=13,  RT_HW_SYS_DEPTH=12,  RT_HW_FCPU=16};
enum{RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4, RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=8, RT_HW_DAC_DEPTH=0}; 
enum{RT_HW_PERMIT_SS=1,	 	RT_HW_SS_RX=68,	   RT_HW_SS_TX=69,		RT_HW_SS_SPEEd=9600};
enum{RT_HW_PERMIT_I2C=1, 	RT_HW_I2C_SDA=20,  RT_HW_I2C_SCL=21,	RT_HW_I2C_FREQ=400};
enum{RT_HW_PERMIT_SPI=1, 	RT_HW_SPI_SS=53,   RT_HW_SPI_MOSI=51,	RT_HW_SPI_MISO=50,	RT_HW_SPI_SCK=52};
//------Макросы проверки пинов---------------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)<22)               ? (p):(-1)) //--Пин любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)>=14) && ((p)<20)  ? (p):(-1)) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define RT_HW_PIN_CHECK_PWM(p)  (digitalPinHasPWM(p)    ? (p):(-1)) //--Пин типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1) 								//--Пин типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Пин типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)>=2)  && ((p)<20)  ? (p):(-1))	//--Пин типа DIR(допускается прямое управление) 
#define RT_HW_PIN_CHECK_INT(p)  digitalPinToInterrupt(p)			//--Номер прерывания по номеру пина
#endif
//=================================================================================================				
//-------------------------------------------------------------------------------------------------
//								3.4.Макросы и функции для прямого управления пинами (PINx,DDRx,PORTx)
//-------------------------------------------------------------------------------------------------
struct  RT_HW_PIN_DIR_ID {uint8_t pin; uint8_t dir; uint16_t mode; uint8_t bit; volatile uint8_t *base;}; //--Структура для прямого управления пинами
#define RT_HW_PIN_DIR_SET_ID(id,p) 	    	id.pin=p; id.bit=digitalPinToBitMask(p); id.base=portInputRegister(digitalPinToPort(p));
#define RT_HW_PIN_DIR_MODE_INPUT(id)        *((id.base)+(1)) &=~id.bit; *((id.base)+(2))&=~id.bit; 
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    *((id.base)+(1)) &=~id.bit;  *((id.base)+(2))|= id.bit;
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    *((id.base)+(1)) |= id.bit;
#define RT_HW_PIN_DIR_READ(id)           (((*((id.base)+(0))) & id.bit) ? (1) : (0)); 
#define RT_HW_PIN_DIR_WRITE(id,val) if(val){*((id.base)+(2)) |= id.bit;} else{*((id.base)+(2)) &= ~id.bit;};
#define RT_HW_PIN_DIR_WRITE_LOW(id)         *((id.base)+(2)) &= ~id.bit;
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        *((id.base)+(2)) |= id.bit;

//*************************************************************************************************
//										II. ПЛАТФОРМА ARDUINO DUE
//*************************************************************************************************
#elif defined(RT_HW_ARCH_DUE)	
//-------------------------------------------------------------------------------------------------
//								2.1.Дополнительные библиотеки
//-------------------------------------------------------------------------------------------------
#include <Wire.h>												//--Подключение библиотеки i2c;	   	
#include <SPI.h>												//--Подключение библиотеки SPI;
//-------------------------------------------------------------------------------------------------
//		                       	2.2.Макросы для работы c пинами через функции WIRING  
//-------------------------------------------------------------------------------------------------
#define RT_HW_PIN_MODE_INPUT				INPUT				//--Дискретный вход;
#define RT_HW_PIN_MODE_INPUT_PULLUP			INPUT_PULLUP 		//--Дискретный вход с подтяжкой к +Vcc;
#define RT_HW_PIN_MODE_OUTPUT				OUTPUT				//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_FLOATING		INPUT				//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN		INPUT				//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG			INPUT				//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN	OUTPUT				//--Дискретный выход с открытым стоком;
#define RT_HW_PIN_MODE_OUTPUT_PWM			OUTPUT				//--ШИМ выход;
#define RT_HW_PIN_MODE_OUTPUT_PWM_OPEN_DRAIN OUTPUT				//--ШИМ выход с открытым коллектором;	
//-------------------------------------------------------------------------------------------------
//		                       	2.3 Пины и параметры контроллеров
//-------------------------------------------------------------------------------------------------
enum{RT_HW_PIN_QNT_MAX=70,	RT_HW_PIN_LED=13,  RT_HW_SYS_DEPTH=12,  RT_HW_FCPU=84};
enum{RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4, RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=8, RT_HW_DAC_DEPTH=0}; 
enum{RT_HW_PERMIT_SS=0,	 	RT_HW_SS_RX=-1,	   RT_HW_SS_TX=-1,		RT_HW_SS_SPEEd=-1};
enum{RT_HW_PERMIT_I2C=1, 	RT_HW_I2C_SDA=20,  RT_HW_I2C_SCL=21,	RT_HW_I2C_FREQ=400};
enum{RT_HW_PERMIT_SPI=1, 	RT_HW_SPI_SS=53,   RT_HW_SPI_MOSI=51,	RT_HW_SPI_MISO=50,	RT_HW_SPI_SCK=52};
//------Макросы проверки пинов---------------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)<RT_HW_PIN_QNT_MAX)? (p):(-1)) //--Пин любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)>=2)  && ((p)<70)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)>=54) && ((p)<70)  ? (p):(-1)) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)>=2)  && ((p)<70)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление)//--Пин типа DIN;
#define RT_HW_PIN_CHECK_PWM(p)  (digitalPinHasPWM(p)    ? (p):(-1)) //--Пин типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (((p)==67)              ? (p):(-1))	//--Пин типа DAC (пин 66 не работает из-за ошибок в библиотеке IDE);
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Пин типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)>=2)  && ((p)<54)  ? (p):(-1)) //--Пин типа DIR(допускается прямое управление);
#define RT_HW_PIN_CHECK_INT(p)  digitalPinToInterrupt(p)			//--Номер прерывания по номеру пина;
//-------------------------------------------------------------------------------------------------
//				     			2.4.Макросы прямого управления дискретными пинами
//-------------------------------------------------------------------------------------------------
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode; uint32_t bit; volatile uint32_t *base;}; //--Структура для прямого управления пинами
#define RT_HW_PIN_DIR_SET_ID(id,p) 	    id.pin=p; id.bit=digitalPinToBitMask(p); id.base=(&(digitalPinToPort(p)->PIO_PER));
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT); 				// *((id.base)+(5))= id.bit;   
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);		// *((id.base)+(6))= id.bit;  
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    *((id.base)+(4))= id.bit;
#define RT_HW_PIN_DIR_READ(id)           	(((*((id.base)+(15))) & id.bit) ? (1) : (0)); 
#define RT_HW_PIN_DIR_WRITE(id,val) 		if(val){*((id.base)+(12))= id.bit;} else{*((id.base)+(13))= id.bit;};
#define RT_HW_PIN_DIR_WRITE_LOW(id)         *((id.base)+(13))= id.bit;
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        *((id.base)+(12))= id.bit;
//-------------------------------------------------------------------------------------------------

//*************************************************************************************************
//										III. ПЛАТФОРМА  ESP8266
//*************************************************************************************************
#elif defined(ARDUINO_ARCH_ESP8266)
//-------------------------------------------------------------------------------------------------
//								3.1.Дополнительные библиотеки
//-------------------------------------------------------------------------------------------------
#include <Wire.h>												//--Подключение библиотеки i2c;	   	
#include <SPI.h>												//--Подключение библиотеки SPI
#include <SoftwareSerial.h>										//--Программный UART;	
//-------------------------------------------------------------------------------------------------
//		                       	3.2.Макросы для работы c пинами через функции WIRING  
//-------------------------------------------------------------------------------------------------
#define RT_HW_PIN_MODE_INPUT  					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_INPUT_PULLUP  			INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
#define RT_HW_PIN_MODE_INPUT_FLOATING  			INPUT			//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN  			INPUT			//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG  			INPUT			//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT  					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN  		OUTPUT			//--Дискретный выход с открытым стоком;
#define RT_HW_PIN_MODE_OUTPUT_PWM  				OUTPUT			//--ШИМ выход;
#define RT_HW_PIN_MODE_OUTPUT_PWM_OPEN_DRAIN 	OUTPUT			//--ШИМ выход с открытым коллектором;
//-------------------------------------------------------------------------------------------------
//		                       	3.3 Пины и параметры контроллеров
//-------------------------------------------------------------------------------------------------
enum{RT_HW_PIN_QNT_MAX=18,	RT_HW_PIN_LED=2,   RT_HW_SYS_DEPTH=12,  RT_HW_FCPU=80};
enum{RT_HW_ADC_DEPTH=10,	RT_HW_ADC_DRIFT=4, RT_HW_ADC_NULL=3,	RT_HW_PWM_DEPTH=10, RT_HW_DAC_DEPTH=0}; 
enum{RT_HW_PERMIT_SS=1,	 	RT_HW_SS_RX=13,	   RT_HW_SS_TX=15,		RT_HW_SS_SPEEd=115200};
enum{RT_HW_PERMIT_I2C=1, 	RT_HW_I2C_SDA=4,   RT_HW_I2C_SCL=5,		RT_HW_I2C_FREQ=400};
enum{RT_HW_PERMIT_SPI=1, 	RT_HW_SPI_SS=15,   RT_HW_SPI_MOSI=13,	RT_HW_SPI_MISO=12,	RT_HW_SPI_SCK=14};
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(!(((p)>=6) && ((p)<=11))) 						//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  (((p) < 18) && RT_HW_PIN_BLOCK_1 ? (p) : -1) 	//--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p) < 16) && RT_HW_PIN_BLOCK_1 ? (p) : -1)  	//--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  ((p) == 17     		   	         ? (p) : -1)	//--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p) < 17) && RT_HW_PIN_BLOCK_1 ? (p) : -1) 	//--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  (((p) < 16) && RT_HW_PIN_BLOCK_1 ? (p) : -1)	//--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)											//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)											//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p) < 16) && RT_HW_PIN_BLOCK_1 ? (p) : -1)    //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p) < 16) && RT_HW_PIN_BLOCK_1 ? (p) : -1)  	//--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
//								3.4.Макросы и функции для прямого управления пинами
//-------------------------------------------------------------------------------------------------												//--Структура для прямого управления пинами
struct  RT_HW_PIN_DIR_ID{uint32_t pin; uint32_t dir; uint16_t mode; uint32_t GPFFS_pin; uint32_t LEFT_PIN; uint32_t LEFT_GPCI; uint32_t LEFT_GPCD; uint32_t LEFT_GPFPU;};
static inline __attribute__((always_inline))		//--Чтение дискретного пина
bool RT_HW_BASE_digitalReadFast(RT_HW_PIN_DIR_ID &id) {if(id.pin < 16){return GPIP(id.pin);} else if(id.pin == 16){return GP16I & 0x01;} return 0;};
#define RT_HW_PIN_DIR_SET_ID(id,p)    id.pin=p; id.GPFFS_pin=GPFFS(GPFFS_GPIO(id.pin)); id.LEFT_PIN=(1<<id.pin); id.LEFT_GPCI=(0xF<<GPCI); id.LEFT_GPCD=(1<<GPCD); id.LEFT_GPFPU=(1<<GPFPU);
#define RT_HW_PIN_DIR_MODE_INPUT(id)  GPF(id.pin)=id.GPFFS_pin; GPEC=id.LEFT_PIN; GPC(id.pin)=(GPC(id.pin) & id.LEFT_GPCI) | (id.LEFT_GPCD);
#define RT_HW_PIN_DIR_MODE_PULLUP(id) GPF(id.pin)=id.GPFFS_pin; GPEC=id.LEFT_PIN; GPC(id.pin)=(GPC(id.pin) & id.LEFT_GPCI) | (id.LEFT_GPCD);  GPF(id.pin) |=id.LEFT_GPFPU;
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) GPF(id.pin)=id.GPFFS_pin; GPC(id.pin)=GPC(id.pin) & id.LEFT_GPCI; GPES = id.LEFT_PIN;
#define RT_HW_PIN_DIR_READ(id)        RT_HW_BASE_digitalReadFast(id);
#define RT_HW_PIN_DIR_WRITE(id,val)   if(val) GPOS=id.LEFT_PIN; else GPOC=id.LEFT_PIN;
#define RT_HW_PIN_DIR_WRITE_LOW(id,val)                              GPOC=id.LEFT_PIN;
#define RT_HW_PIN_DIR_WRITE_HIGH(id,val)      GPOS=id.LEFT_PIN;
//-------------------------------------------------------------------------------------------------

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									IV.ПЛАТФОРМА  ESP32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#elif defined(RT_HW_ARCH_ESP32)
//-------------------------------------------------------------------------------------------------
//								4.1.Дополнительные библиотеки
//-------------------------------------------------------------------------------------------------
#include <Wire.h>												//--Подключение библиотеки i2c;	   	
#include <SPI.h>												//--Подключение библиотеки SPI	
#include "esp32-hal-ledc.h"										//--Библиотека для работы с PWM  и LED	
#include <driver/rtc_io.h>										//--
//-------------------------------------------------------------------------------------------------
//								4.2.Макросы для работы с функциями WIRING
//-------------------------------------------------------------------------------------------------
#define RT_HW_PIN_MODE_INPUT				INPUT				//--Дискретный вход
#define RT_HW_PIN_MODE_INPUT_PULLUP			INPUT_PULLUP 		//--Дискретный вход с подтяжкой к +Vcc
#define RT_HW_PIN_MODE_OUTPUT				OUTPUT				//--Дискретный выход
#define RT_HW_PIN_MODE_INPUT_FLOATING		INPUT				//--Дискретный вход - аналог INPUT
#define RT_HW_PIN_MODE_INPUT_PULLDOWN		INPUT_PULLDOWN		//--Дискретный вход с подтяжкой к GND
#define RT_HW_PIN_MODE_INPUT_ANALOG			INPUT				//--Аналоговый вход
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN	OUTPUT_OPEN_DRAIN	//--Дискретный выход с открытым стоком
#define RT_HW_PIN_MODE_OUTPUT_PWM			OUTPUT				//--ШИМ выход
#define RT_HW_PIN_MODE_OUTPUT_PWM_OPEN_DRAIN OUTPUT				//--ШИМ выход с открытым коллектором	
//-------------------------------------------------------------------------------------------------
//		                       	4.3 Пины и параметры контроллеров
//-------------------------------------------------------------------------------------------------
enum{RT_HW_PIN_QNT_MAX=40,	RT_HW_PIN_LED=2,    RT_HW_SYS_DEPTH=12, RT_HW_FCPU=160};
enum{RT_HW_ADC_DEPTH=12,	RT_HW_ADC_DRIFT=10, RT_HW_ADC_NULL=10,	RT_HW_PWM_DEPTH=12, RT_HW_DAC_DEPTH=8}; 
enum{RT_HW_PERMIT_SS=0,	 	RT_HW_SS_RX=-1,	    RT_HW_SS_TX=-1,		RT_HW_SS_SPEEd=-1};
enum{RT_HW_PERMIT_I2C=1, 	RT_HW_I2C_SDA=21,   RT_HW_I2C_SCL=22,	RT_HW_I2C_FREQ=400};
enum{RT_HW_PERMIT_SPI=1, 	RT_HW_SPI_SS=5,     RT_HW_SPI_MOSI=23,	RT_HW_SPI_MISO=19,	RT_HW_SPI_SCK=18};
//-------------------------------------------------------------------------------------------------
//		                       	4.3 Пины и параметры контроллеров
//-------------------------------------------------------------------------------------------------
//------Используемые макросы-----------------------------------------------------------------------
#define RT_HW_PIN_LED			2								//--Номер пина со светодиодом;
#define RT_HW_PIN_QNT_MAX		40								//--Максимальное кол-во пинов;
#define RT_HW_ESP32_HALL_NULL			10						//--Дрейф показаний датчика Холла (ESP32); 
#define RT_HW_ESP32_HALL_DRIFT			5						//--Дрейф нулей     датчика Холла (ESP32); 
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_QNT_MAX		40								                    //--Максимальное кол-во пинов;
#define	RT_HW_PIN_CHECK_ALL(p)  ((p) < 40	                            ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  ((p) < 40                               ? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  ((((p) >=32) && ((p) <=39))   		   	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  ((p) < 34	                            ? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  ((p) < 34                               ? (p) : -1) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  ((((p)==25)  || ((p)==26))        		? (p) : -1)	//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  ((p)==4  || (p)==0 ||(p)==2 || (p)==4  || (p)==15 || (p)==13 \
              || (p)==12 || (p)==14 || (p)==27 || (p)==33 || (p)==32    ? (p) : -1) //--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  ((p) < 34	                            ? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  ((p) < 34	                            ? (p) : -1) //--Номер прерывания по номеру пин;
//-------------------------------------------------------------------------------------------------
//								4.4.Макросы и функции для прямого управления пинами
//-------------------------------------------------------------------------------------------------	
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode; uint32_t bit;}; //--Структура для прямого управления пинами			}	
//-------------------------------------------------------------------------------------------------		
#define RT_HW_PIN_DIR_SET_ID(id,p) 	        id.pin=p; id.bit=id.pin; 
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT);
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    pinMode(id.pin,OUTPUT);
#define RT_HW_PIN_DIR_READ(id)              digitalRead(id.pin);
#define RT_HW_PIN_DIR_WRITE(id,val) 		digitalWrite(id.pin,val);
#define RT_HW_PIN_DIR_WRITE_LOW(id)         digitalWrite(id.pin,0);
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        digitalWrite(id.pin,1);
//-------------------------------------------------------------------------------------------------
#ifdef  interrupts
#undef  interrupts
#endif
#ifdef  noInterrupts
#undef  noInterrupts
#endif
#define noInterrupts() {portMUX_TYPE mux = portMUX_INITIALIZER_UNLOCKED; portENTER_CRITICAL(&mux)
#define interrupts() portEXIT_CRITICAL(&mux);}
//=================================================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//										ПЛАТФОРМА  STM32
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#elif defined(ARDUINO_ARCH_STM32)
//-------------------------------------------------------------------------------------------------
//								5.1.Дополнительные библиотеки
//-------------------------------------------------------------------------------------------------
#include <Wire.h>												//--Подключение библиотеки i2c;	   	
#include <SPI.h>												//--Подключение библиотеки SPI;	
//-------------------------------------------------------------------------------------------------
//								5.2.Макросы для работы с функциями WIRING
//-------------------------------------------------------------------------------------------------
#define RT_HW_PIN_MODE_INPUT					INPUT			//--Дискретный вход;
#define RT_HW_PIN_MODE_INPUT_PULLUP				INPUT_PULLUP 	//--Дискретный вход с подтяжкой к +Vcc;
#define RT_HW_PIN_MODE_OUTPUT					OUTPUT			//--Дискретный выход;
#define RT_HW_PIN_MODE_INPUT_FLOATING			INPUT_FLOATING	//--Дискретный вход - аналог INPUT;
#define RT_HW_PIN_MODE_INPUT_PULLDOWN			INPUT_PULLDOWN	//--Дискретный вход с подтяжкой к GND;
#define RT_HW_PIN_MODE_INPUT_ANALOG				INPUT_ANALOG	//--Аналоговый вход;
#define RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN	OUTPUT_OPEN_DRAIN	//--Дискретный выход с открытым стоком;
#define RT_HW_PIN_MODE_OUTPUT_PWM				PWM				//--ШИМ выход;
#define RT_HW_PIN_MODE_OUTPUT_PWM_OPEN_DRAIN	PWM_OPEN_DRAIN	//--ШИМ выход с открытым коллектором;
//-------------------------------------------------------------------------------------------------
//		                       	5.3 Пины и параметры контроллеров
//------------------------------------------------------------------------------------------------- 
//===============================Контроллеры типа STM32F103c=======================================
#if defined(RT_HW_BOARD_STM32F103C)	
//------Используемые макросы-----------------------------------------------------------------------
#define RT_HW_PIN_LED			32								//--Номер пина со светодиодом(PC13);
#define RT_HW_PIN_QNT_MAX		35								//--Максимальное кол-во пинов;
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(((p)!=11)&&((p)!=12)&&((p)!=13)&&((p)!=14)&&((p)!=33)&&((p)!=34))	//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  ( (p)< 35	                            ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)<=31) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)<=7) || ((p)==16) || ((p)==17)  	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)<=32) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  ((((p)<=10) &&(((p)!=4)&& ((p)!=5))) ||((p)==16)||((p)==17)||(((p)>=22)&&((p)<=25))?(p):-1) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        										//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)												//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)<=31)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p)<=31)&&RT_HW_PIN_BLOCK_1			? (p) : -1) //--Номер прерывания по номеру пин;
//------Массивы с параметрами----------------------------------------------------------------------
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_GEN)	={6,12,12,0,10,10,72}; 		//--Байты 1-3:разряд.АЦП,PWM,ЦАП; Байты 4,5:дрейфы нуля,показаний АЦП(в ед.АЦП); Байт 6:Fcpu;
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_LINK)  ={3,0x0f,0x33,0x01};	    //--Байт 1:SS,UART6-UART0; Байт 2:0,0,spi2,spi1,0,0,i2c2,i2c1; Байт 3:0,0,0,0,Eth,BT,WiFi,CAN;
//------Массивы с пинами каналов связи-------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_UHS)	={8,12,11,10,9,3,2,27,26};	//--UART:RX,TX; UAR1:RX1,TX1; UART2:RX2,TX2; UART3:RX3,TX3;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_USS)	={0};						//--;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_I2C)	={4,23,22,27,26};			//--i2c:SDA1,SCL1; SDA2,SCL2; 
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_SPI)	={8,4,7,6,5,28,31,30,29};	//--SPI:SS1,MOSI1,MISO1,SCK1; SS2,MOSI2,MISO2,SCK2;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_CAN)    ={0};						//--CAN:RX,TX;
//===============================Контроллеры типа STM32F10R=======================================
#elif defined(RT_HW_BOARD_STM32F103R)	
//------Макрос извлечения байта из PROGMEM---------------------------------------------------------		
//#define RT_HW_READ_BYTE_PGM(arr,n) 	pgm_read_byte(arr+n)	//--Чтение из массива arr байта с номером n(для >64 kB);
//------Используемые макросы-----------------------------------------------------------------------
#define RT_HW_PIN_LED			-1								//--Номер пина со светодиодом(PC13);
#define RT_HW_PIN_QNT_MAX		49								//--Максимальное кол-во пинов;
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(((p)!=11)&&((p)!=12)&&((p)!=13)&&((p)!=14)&&((p)!=46)&&((p)!=47))	//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  (((p)< 49) 						        ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)< 49) &&  RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)<=7) || ((p)==16) || ((p)==17)  	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)< 49) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p) ((((p)>= 0)&&((p)<=10)&&((p)!=4)&&((p)!=5))||((p)==16)||((p)==17)||(((p)>=22)&&((p)<=25))?(p):-1) //--Наличие пина типа PWM;//--Наличие пина типа PWM;  //==19
#define RT_HW_PIN_CHECK_DAC(p)  (((p)==4) || ((p)==5)  				 	? (p) : -1) //--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)												//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)< 49)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p)< 49)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Номер прерывания по номеру пин;
//------Массивы с параметрами----------------------------------------------------------------------
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_GEN)	={6,12,12,8,10,10,72}; 		//--Байты 1-3:разряд.АЦП,PWM,ЦАП; Байты 4,5:дрейфы нуля,показаний АЦП(в ед.АЦП); Байт 6:Fcpu;
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_LINK)  ={3,0x1f,0x33,0x01};		//--Байт 1:SS,UART6-UART0; Байт 2:0,0,spi1,spi,0,0,i2c1,i2c; Байт 3:0,0,0,0,Eth,BT,WiFi,CAN;
//------Массивы с пинами каналов связи-------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_UHS)	={12,12,11,10,9,3,2,27,26,43,42,48,44};	//--UART:RX,TX; UAR1:RX1,TX1; UART2:RX2,TX2; UART3:RX3,TX3;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_USS)	={0};						//--;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_I2C)	={2,21,22};					//--i2c:SDA,SCL; 
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_SPI)	={4,5,23,19,18};		    //--SPI:SS,MOSI,MISO,SCK;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_CAN)    ={0};						//--CAN:RX,TX;
//===============================Контроллеры типа STM32F103V (отладка)=============================
#elif defined(RT_HW_BOARD_STM32F103V)	
//------Макрос извлечения байта из PROGMEM---------------------------------------------------------		
//#define RT_HW_READ_BYTE_PGM(arr,n) 	pgm_read_byte(arr+n)	//--Чтение из массива arr байта с номером n(для >64 kB);
//------Используемые макросы-----------------------------------------------------------------------
#define RT_HW_PIN_LED			-1								//--Номер пина со светодиодом(PC13);
#define RT_HW_PIN_QNT_MAX		35								//--Максимальное кол-во пинов;
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(((p)!=11)&&((p)!=12)&&((p)!=13)&&((p)!=14)&&((p)!=33)&&((p)!=34))	//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  ( (p)< 35	                            ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)<=31) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)<=7) || ((p)==16) || ((p)==17)  	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)<=32) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p) ((((p)>= 0)&&((p)<=10)&&((p)!=4)&&((p)!=5))||((p)==16)||((p)==17)||(((p)>=22)&&((p)<=25))?(p):-1) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        										//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)												//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)<=31)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p)<=31)&&RT_HW_PIN_BLOCK_1			? (p) : -1) //--Номер прерывания по номеру пин;
//------Массивы с параметрами----------------------------------------------------------------------
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_GEN)	={6,12,12,8,10,10,80}; 	//--Байты 1-3:разряд.АЦП,PWM,ЦАП; Байты 4,5:дрейфы нуля,показаний АЦП(в ед.АЦП); Байт 6:Fcpu;
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_LINK)  ={3,0x05,0x11,B00000110};//--Байт 1:SS,UART6-UART0; Байт 2:0,0,spi1,spi,0,0,i2c1,i2c; Байт 3:0,0,0,0,Eth,BT,WiFi,CAN;
//------Массивы с пинами каналов связи-------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_UHS)	={6,3,1,-1,-1,16,17};	//--UART:RX,TX; UAR1:RX1,TX1; UART2:RX2,TX2; UART3:RX3,TX3;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_USS)	={0};					//--;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_I2C)	={2,21,22};				//--i2c:SDA,SCL; 
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_SPI)	={4,5,23,19,18};		//--SPI:SS,MOSI,MISO,SCK;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_CAN)    ={0};					//--CAN:RX,TX;
//===============================Контроллеры типа STM32F103Z (отладка)=============================
#elif defined(RT_HW_BOARD_STM32F103Z)	
//------Макрос извлечения байта из PROGMEM---------------------------------------------------------		
//#define RT_HW_READ_BYTE_PGM(arr,n) 	pgm_read_byte(arr+n)	//--Чтение из массива arr байта с номером n(для >64 kB);
//------Используемые макросы-----------------------------------------------------------------------
#define RT_HW_PIN_LED			-1								//--Номер пина со светодиодом(PC13);
#define RT_HW_PIN_QNT_MAX		35								//--Максимальное кол-во пинов;
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(((p)!=11)&&((p)!=12)&&((p)!=13)&&((p)!=14)&&((p)!=33)&&((p)!=34))	//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  ( (p)< 35	                            ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)<=31) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)<=7) || ((p)==16) || ((p)==17)  	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)<=32) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p) ((((p)>= 0)&&((p)<=10)&&((p)!=4)&&((p)!=5))||((p)==16)||((p)==17)||(((p)>=22)&&((p)<=25))?(p):-1) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        										//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)												//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)<=31)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p)<=31)&&RT_HW_PIN_BLOCK_1			? (p) : -1) //--Номер прерывания по номеру пин;
//------Массивы с параметрами----------------------------------------------------------------------
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_GEN)	={6,12,12,8,10,10,80}; 	//--Байты 1-3:разряд.АЦП,PWM,ЦАП; Байты 4,5:дрейфы нуля,показаний АЦП(в ед.АЦП); Байт 6:Fcpu;
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_LINK)  ={3,0x05,0x11,B00000110};//--Байт 1:SS,UART6-UART0; Байт 2:0,0,spi1,spi,0,0,i2c1,i2c; Байт 3:0,0,0,0,Eth,BT,WiFi,CAN;
//------Массивы с пинами каналов связи-------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_UHS)	={6,3,1,-1,-1,16,17};	//--UART:RX,TX; UAR1:RX1,TX1; UART2:RX2,TX2; UART3:RX3,TX3;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_USS)	={0};					//--;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_I2C)	={2,21,22};				//--i2c:SDA,SCL; 
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_SPI)	={4,5,23,19,18};		//--SPI:SS,MOSI,MISO,SCK;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_CAN)    ={0};					//--CAN:RX,TX;
//===============================Контроллеры типа STM32F1_ANON=====================================
#else
//------Используемые макросы-----------------------------------------------------------------------
#define RT_HW_PIN_LED			-1								//--Номер пина со светодиодом(PC13);
#define RT_HW_PIN_QNT_MAX		35								//--Максимальное кол-во пинов;
//------Макросы проверки пинов---------------------------------------------------------------------
#define RT_HW_PIN_BLOCK_1  		(((p)!=11)&&((p)!=12)&&((p)!=13)&&((p)!=14)&&((p)!=33)&&((p)!=34))	//--Запрещенный набор пинов;	
#define	RT_HW_PIN_CHECK_ALL(p)  ( (p)< 35	                            ? (p) : -1) //--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  (((p)<=31) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (((p)<=7) || ((p)==16) || ((p)==17)  	? (p) : -1) //--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  (((p)<=32) && RT_HW_PIN_BLOCK_1 		? (p) : -1) //--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p) ((((p)>= 0)&&((p)<=10)&&((p)!=4)&&((p)!=5))||((p)==16)||((p)==17)||(((p)>=22)&&((p)<=25))?(p):-1) //--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)        										//--Наличие пина типа DAC;  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)												//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_DIR(p)  (((p)<=31)&&RT_HW_PIN_BLOCK_1 			? (p) : -1) //--Наличие пина типа DIR; 
#define RT_HW_PIN_CHECK_INT(p)  (((p)<=31)&&RT_HW_PIN_BLOCK_1			? (p) : -1) //--Номер прерывания по номеру пин;
//------Массивы с параметрами----------------------------------------------------------------------
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_GEN)	={6,12,12,8,10,10,80}; 	//--Байты 1-3:разряд.АЦП,PWM,ЦАП; Байты 4,5:дрейфы нуля,показаний АЦП(в ед.АЦП); Байт 6:Fcpu;
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_LINK)  ={3,0x05,0x11,B00000110};//--Байт 1:SS,UART6-UART0; Байт 2:0,0,spi1,spi,0,0,i2c1,i2c; Байт 3:0,0,0,0,Eth,BT,WiFi,CAN;
//------Массивы с пинами каналов связи-------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_UHS)	={6,3,1,-1,-1,16,17};	//--UART:RX,TX; UAR1:RX1,TX1; UART2:RX2,TX2; UART3:RX3,TX3;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_USS)	={0};					//--;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_I2C)	={2,21,22};				//--i2c:SDA,SCL; 
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_SPI)	={4,5,23,19,18};		//--SPI:SS,MOSI,MISO,SCK;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_CAN)    ={0};					//--CAN:RX,TX;
//-------------------------------------------------------------------------------------------------
#endif
//-------------------------------------------------------------------------------------------------
//								5.4.Макросы и функции для прямого управления пинами
//-------------------------------------------------------------------------------------------------	
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode; uint32_t bit; volatile uint32_t *base;}; //--Структура для прямого управления пинами
#define RT_HW_PIN_DIR_SET_ID(id,p) 	       id.pin=p; id.bit=id.pin; 
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT);			//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);	//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    pinMode(id.pin,OUTPUT);			//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_OUTPUT_PP, GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_READ(id)              digitalRead(id.pin);			//digitalReadFast((PinName)id.pin);  //digitalRead(id.pin);
#define RT_HW_PIN_DIR_WRITE(id,val) 		digitalWrite(id.pin,val);		//if(val){digitalWriteFast((PinName)id.pin, HIGH);} else {digitalWriteFast((PinName)id.pin,LOW);} //digitalWrite(id.pin,val);
#define RT_HW_PIN_DIR_WRITE_LOW(id)         digitalWrite(id.pin,0);			//digitalWriteFast((PinName)id.pin, LOW); 	//digitalWrite(id.pin,0);
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        digitalWrite(id.pin,l);			//digitalWriteFast((PinName)id.pin, HIGH);	//digitalWrite(id.pin,1);
//=================================================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//										ПЛАТФОРМА  ANON (резервный режим)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#else
//-------------------------------------------------------------------------------------------------
//								9.1.Дополнительные библиотеки
//-------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
//								9.2.Макросы для работы с функциями WIRING
//-------------------------------------------------------------------------------------------------
#define RT_HW_PIN_NUM_ALL 				(20) 					//--Общее кол-во доступных пинов;
#define RT_HW_PIN_NUM_DIG				(20) 					//--Кол-во дискретных пинов;
#define RT_HW_PIN_NUM_DIN 				(20)					//--Кол-во входных  дискретных пинов;	
#define RT_HW_PIN_NUM_ADC  				(0)						//--Кол-во входных  аналоговых пинов;
#define RT_HW_PIN_NUM_DOT  				(20)					//--Кол-во выходных дискретных пинов;
#define RT_HW_PIN_NUM_PWM  				(0)						//--Кол-во пинов с PWM;
#define RT_HW_PIN_NUM_DAC  				(0) 					//--Кол-во выходных аналоговых пинов;
#define RT_HW_PIN_NUM_TCH  				(0) 					//--Кол-во сенсорных пинов;
#define RT_HW_PIN_NUM_NON  				(0) 					//--Кол-во пинов зарезервированного типа;
//-------------------------------------------------------------------------------------------------
//		Параметры под конкретный контроллер серии AVR - идентификатор, коде и имя контроллера,
//		общее кол-во пинов, кол-во пинов с PWM, контроль наличия пина типа ADC	
//-------------------------------------------------------------------------------------------------	
#define RT_HW_BOARD_ANON										//--Идентификатор контроллера
#define RT_HW_BOARD_CODE			RT_HW_ID_BOARD_ANON			//--Код контроллера;
#define RT_HW_BOARD_NAME			"ANON"						//--Наименование контроллера; 
//-------------------------------------------------------------------------------------------------
//								9.3.Макросы с учетом типа контроллера
//-------------------------------------------------------------------------------------------------
#define	RT_HW_PIN_CHECK_ALL(p)  ((p<RT_HW_PIN_NUM_ALL) ? (p):(-1))	//--Наличие пина любого типа;
#define RT_HW_PIN_CHECK_DIN(p)  ((p<RT_HW_PIN_NUM_DIG) ? (p):(-1))	//--Наличие пина типа DIN;
#define	RT_HW_PIN_CHECK_ADC(p)  (-1)								//--Наличие пина контроллера типа ADC;
#define RT_HW_PIN_CHECK_DOT(p)  ((p<RT_HW_PIN_NUM_DIG) ? (p):(-1))	//--Наличие пина типа DOT;
#define RT_HW_PIN_CHECK_PWM(p)  (-1)								//--Наличие пина типа PWM;  
#define RT_HW_PIN_CHECK_DAC(p)  (-1)								//--Наличие пина типа DAC (пин 70 не работает!);  
#define RT_HW_PIN_CHECK_TCH(p)  (-1)								//--Наличие пина типа TCH; 
#define RT_HW_PIN_CHECK_NON(p)  (-1) 								//--Наличие пина типа NON; 
//------Массивы с параметрами----------------------------------------------------------------------
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_GEN)	={6,0,0,0,0,0,8}; 		//--Байты 1-3:разряд.АЦП,PWM,ЦАП; Байты 4,5:дрейфы нуля,показаний АЦП(в ед.АЦП); Байт 6:Fcpu;
RT_HW_BUILD_BYTE_PGM(RT_HW_PARAM_LINK)  ={3,0x01,0x11,0};		//--Байт 1:SS,UART6-UART0; Байт 2:0,0,spi1,spi,0,0,i2c1,i2c; Байт 3:0,0,0,0,Eth,BT,WiFi,CAN;
//------Массивы с пинами каналов связи-------------------------------------------------------------
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_UHS)	={2,0};					//--UART:RX,TX; UAR1:RX1,TX1; UART2:RX2,TX2; UART3:RX3,TX3;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_USS)	={0};					//--;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_I2C)	={2,21,22};				//--i2c:SDA,SCL; 
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_SPI)	={4,5,23,19,18};		//--SPI:SS,MOSI,MISO,SCK;
RT_HW_BUILD_INT8_PGM(RT_HW_PINS_CAN)    ={0};					//--CAN:RX,TX;
//-------------------------------------------------------------------------------------------------
//								9.4.Макросы и функции для прямого управления пинами
//-------------------------------------------------------------------------------------------------
struct  RT_HW_PIN_DIR_ID {uint32_t pin; uint32_t dir; uint32_t mode;}; //--Структура для прямого управления пинами
#define RT_HW_PIN_DIR_SET_ID(id,p) 	       id.pin=p; id.bit=id.pin; 
#define RT_HW_PIN_DIR_MODE_INPUT(id)        pinMode(id.pin,INPUT);			//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_PULLUP(id) 	    pinMode(id.pin,INPUT_PULLUP);	//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_INPUT,     GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_MODE_OUTPUT(id) 	    pinMode(id.pin,OUTPUT);			//pin_function((PinName)id.pin, STM_PIN_DATA(STM_MODE_OUTPUT_PP, GPIO_NOPULL,0))
#define RT_HW_PIN_DIR_READ(id)              digitalRead(id.pin);			//digitalReadFast((PinName)id.pin);  //digitalRead(id.pin);
#define RT_HW_PIN_DIR_WRITE(id,val) 		digitalWrite(id.pin,val);		//if(val){digitalWriteFast((PinName)id.pin, HIGH);} else {digitalWriteFast((PinName)id.pin,LOW);} //digitalWrite(id.pin,val);
#define RT_HW_PIN_DIR_WRITE_LOW(id)         digitalWrite(id.pin,0);			//digitalWriteFast((PinName)id.pin, LOW); 	//digitalWrite(id.pin,0);
#define RT_HW_PIN_DIR_WRITE_HIGH(id)        digitalWrite(id.pin,l);			//digitalWriteFast((PinName)id.pin, HIGH);	//digitalWrite(id.pin,1);
//=================================================================================================
#endif			//--Завершение выбора параметров индивидуальных платформ
//=================================================================================================